<?php
namespace Teknisa\CDP\Factories;

use Doctrine\ORM\EntityManager; 

class AtividadeAppFactory {
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager    = $entityManager;
        $this->connection       = $entityManager->getConnection();
    }
    
    public function isCompleted($cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $IDSITGRAVCONT, $nrorg){
        $IDSITGRAVCONT = 'C';
        try {
         
            $sql = "SELECT *
                    FROM RECURETAPAOP 
                   WHERE CDFILIAL      = :CDFILIAL
                     AND NRAUDITORIA   = :NRAUDITORIA
                     AND NRINSPECAUDI  = :NRINSPECAUDI 
                     AND NRRECUETAPOP  = :NRRECUETAPOP
                     AND IDSITGRAVCONT = :IDSITGRAVCONT
                     AND NRORG         = :NRORG 
                     AND DTFINUTRECOP IS NOT NULL";

            $params = array(
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'IDSITGRAVCONT'=>$IDSITGRAVCONT,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
        
    }  
    
    public function inProgress($cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $nrorg){
        try {
         
            $sql = "SELECT *
                    FROM RECURETAPAOP 
                   WHERE CDFILIAL     = :CDFILIAL
                     AND NRAUDITORIA  = :NRAUDITORIA
                     AND NRINSPECAUDI = :NRINSPECAUDI 
                     AND NRRECUETAPOP = :NRRECUETAPOP
                     AND NRORG        = :NRORG 
                     AND DTINIUTRECOP IS NOT NULL";

            $params = array(
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
        
    }
    
    public function isPending($cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $IDSITGRAVCONT, $nrorg){
        $IDSITGRAVCONT = 'P';
        try {
            $sql = "SELECT *
                    FROM RECURETAPAOP 
                   WHERE CDFILIAL      = :CDFILIAL
                     AND NRAUDITORIA   = :NRAUDITORIA
                     AND NRINSPECAUDI  = :NRINSPECAUDI 
                     AND NRRECUETAPOP  = :NRRECUETAPOP
                     AND NRORG         = :NRORG 
                     AND IDSITGRAVCONT = :IDSITGRAVCONT
                     AND DTINIUTRECOP  IS NOT NULL";
                     
            $params = array(
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'IDSITGRAVCONT'=>$IDSITGRAVCONT,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
        
    }
    
    public function isTheFirst($cdfilial, $nrauditoria, $nrinspecaudi, $nrorg){
        try {
            $sql = "SELECT count(*) as COUNT
                      FROM RECURETAPAOP
                     WHERE CDFILIAL     = :CDFILIAL
                       AND NRAUDITORIA  = :NRAUDITORIA
                       AND NRINSPECAUDI = :NRINSPECAUDI  
                       AND DTINIUTRECOP IS NOT NULL
                       AND NRORG        = :NRORG";
                     
            $params = array(
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function initTask($DTINIRINSAUD, $cdfilial, $nrauditoria, $nrinspecaudi, $cdoperador){
        try {
            $sql = "UPDATE INSPECAUDIT
                          SET DTINIRINSAUD = :DTINIRINSAUD,
                          CDOPERADOR       = :CDOPERADOR 
                        WHERE CDFILIAL     = :CDFILIAL    
                          AND NRAUDITORIA  = :NRAUDITORIA 
                          AND NRINSPECAUDI = :NRINSPECAUDI";
                     
            $params = array(
                'DTINIRINSAUD'=>$DTINIRINSAUD,
                'CDOPERADOR'=>$cdoperador,
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function initActivity($DTINIUTRECOP, $cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $nrorg, $cdoperador){
        try {
            $sql = "UPDATE RECURETAPAOP 
                      SET DTINIUTRECOP = :DTINIUTRECOP ,
                          CDOPERADOR   = :CDOPERADOR 
                    WHERE CDFILIAL     = :CDFILIAL 
                      AND NRAUDITORIA  = :NRAUDITORIA 
                      AND NRINSPECAUDI = :NRINSPECAUDI 
                      AND NRRECUETAPOP = :NRRECUETAPOP 
                      AND NRORG        = :NRORG";
                     
            $params = array(
                'DTINIUTRECOP'=>$DTINIUTRECOP,
                'CDOPERADOR'=>$cdoperador,
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getTaskDtInit($cdfilial, $nrauditoria, $nrinspecaudi){
        try {
            $sql = "SELECT 
                    (((TO_CHAR(SYSDATE, 'J') * 86400) + (TO_CHAR(SYSDATE, 'SSSSS'))) - ((TO_CHAR(DTINIRINSAUD, 'J') * 86400) + (TO_CHAR(DTINIRINSAUD, 'SSSSS'))))/(60*60) AS DTINIRINSAUD
                        FROM INSPECAUDIT 
                       WHERE CDFILIAL     = :CDFILIAL
                         AND NRAUDITORIA  = :NRAUDITORIA
                         AND NRINSPECAUDI = :NRINSPECAUDI";
                     
            $params = array(
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
 
    public function isTheLast($cdfilial, $nrauditoria, $nrinspecaudi, $nrorg){
        try {
            $sql = "SELECT count(*) as COUNT
                      FROM RECURETAPAOP
                        WHERE CDFILIAL      =  :CDFILIAL
                        AND NRAUDITORIA   =  :NRAUDITORIA
                        AND NRINSPECAUDI  =  :NRINSPECAUDI
                        AND NRRECURPAI IS NULL
                        AND IDSITGRAVCONT <> 'C'
                        AND NRORG         =  :NRORG";
                     
            $params = array(
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function completeTask($DTINIRINSAUD, $SYSDATE, $cdfilial, $nrauditoria, $nrinspecaudi){
        try {
            $sql = "UPDATE INSPECAUDIT
                      SET DTFINRINSAUD = :DTFINRINSAUD,
                          QTHRINSAUD   = :QTHRINSAUD,
                          IDINSPCONC   = 'S'
                    WHERE CDFILIAL     = :CDFILIAL
                      AND NRAUDITORIA  = :NRAUDITORIA
                      AND NRINSPECAUDI = :NRINSPECAUDI";
                     
            $params = array(
                'QTHRINSAUD'=>$DTINIRINSAUD,
                'DTFINRINSAUD'=>$SYSDATE,
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function changeStatusAudit($cdfilial, $nrauditoria, $idstatusaudi){
        try {
            $sql = "UPDATE AUDITORIA
                    SET IDSTATUSAUDI    = :P_IDSTATUSAUDI
                    WHERE CDFILIAL      = :P_CDFILIAL 
                    AND NRAUDITORIA     = :P_NRAUDITORIA";
                     
            $params = array(
                'P_CDFILIAL'        => $cdfilial,
                'P_NRAUDITORIA'     => $nrauditoria,
                'P_IDSTATUSAUDI'    => $idstatusaudi
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function completeActivity($cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $nrorg, $qttotal, $dtfinal){
        try {
            
            $sql = "UPDATE RECURETAPAOP 
                        SET IDSITGRAVCONT = 'C',
                            QTHRREARECOP  = :QTHRREARECOP,
                            DTFINUTRECOP  = :DTFINUTRECOP
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI
                        AND NRRECUETAPOP  = :NRRECUETAPOP
                        AND NRORG         = :NRORG ";
                     
            $params = array(
                'QTHRREARECOP'=>$qttotal,
                'DTFINUTRECOP'=>$dtfinal,
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function completeAndPauseActivity($cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $nrorg, $qttotal){
        try {
            $sql = "UPDATE RECURETAPAOP 
                        SET IDSITGRAVCONT = 'C',
                        QTHRREARECOP  = :QTHRREARECOP
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI
                        AND NRRECUETAPOP  = :NRRECUETAPOP
                        AND NRORG         = :NRORG ";
                     
            $params = array(
                'QTHRREARECOP'=>$qttotal,
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function completePausedActivity($cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $nrorg, $qttotal){
        try {
            $sql = "UPDATE RECURETAPAOP 
                        SET IDSITGRAVCONT = 'C',
                         QTHRREARECOP  = :QTHRREARECOP
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI
                        AND NRRECUETAPOP  = :NRRECUETAPOP
                        AND NRORG         = :NRORG";
                     
            $params = array(
                'QTHRREARECOP'=>$qttotal,
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function pauseActivityFather($row){
        try {
            $sql = "UPDATE RECURETAPAOP 
                        SET IDSITGRAVCONT = 'A'
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI
                        AND NRRECUETAPOP  = :NRRECUETAPOP
                        AND NRORG         = :NRORG";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function pauseActivity($row){
        try {
            $sql = "UPDATE RECURETAPAOP 
                        SET DTFINUTRECOP  = :DTFINUTRECOP,
                            IDSITGRAVCONT = 'A'
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI
                        AND NRRECUETAPOP  = :NRRECUETAPOP
                        AND NRORG         = :NRORG";
                     
            $params = array(
                'DTFINUTRECOP'=>$row['PAUSE_DATE'],
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function unpauseActivity($row){
        try {
            $sql = "UPDATE RECURETAPAOP 
                        SET IDSITGRAVCONT = 'P'
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI
                        AND NRRECUETAPOP  = :NRRECUETAPOP
                        AND NRORG         = :NRORG ";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            $return = $this->SELECTmaxNRRECUETAPOP($row);
            return $return;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
     
    public function SELECTmaxNRRECUETAPOPComplete($row){
        try {
            $sql = "SELECT max(NRRECUETAPOP) AS LASTID
                        FROM RECURETAPAOP 
                       WHERE CDFILIAL     = :CDFILIAL
                         AND NRAUDITORIA  = :NRAUDITORIA
                         AND NRINSPECAUDI = :NRINSPECAUDI
                         AND NRORG        = :NRORG 
                         AND CDINSPECAO   = :CDINSPECAO";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'CDINSPECAO'=>$row['CDINSPECAO'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            $result = $std->fetchAll();
            return $result[0]['LASTID'];    
                
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function SELECTmaxNRRECUETAPOP($row){
        try {
            $sql = "SELECT max(NRRECUETAPOP) AS LASTID
                        FROM RECURETAPAOP 
                       WHERE CDFILIAL     = :CDFILIAL
                         AND NRAUDITORIA  = :NRAUDITORIA
                         AND NRINSPECAUDI = :NRINSPECAUDI
                         AND NRORG        = :NRORG 
                         AND CDINSPECAO   = :CDINSPECAO";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'CDINSPECAO'=>$row['CDINSPECAO'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            $result = $std->fetchAll();
            $newNrrecuetapop = intval($result[0]['LASTID']) + 1;
            $zeros = '';
            $toString  = (string)$newNrrecuetapop; 
            for($i=0; $i<(3-strlen($toString));$i++){
               $zeros = $zeros.'0';
            }
            $newNrrecuetapop = $zeros.(string)$newNrrecuetapop;
            $nrpai = $row['NRRECURPAI'] == ''? $row['NRRECUETAPOP'] : $row['NRRECURPAI'];
            $return = $this->buildNewActivity($row, $newNrrecuetapop, $nrpai);
            return $return;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function buildNewActivity($row, $newNrrecuetapop, $nrpai){
        try {
            $sql = "INSERT INTO RECURETAPAOP 
                               (IDSITGRAVCONT, CDFILIAL, NRAUDITORIA, NRINSPECAUDI, NRRECUETAPOP, NRORG, CDINSPECAO, CDHABILIDADE, CDEQUIPPRO, CDOPERADOR, IDRECURETAOP, NRRECURPAI, DTINIUTRECOP)
                                    VALUES (:IDSITGRAVCONT, 
                                            :CDFILIAL, 
                                            :NRAUDITORIA, 
                                            :NRINSPECAUDI, 
                                            :NRRECUETAPOP, 
                                            :NRORG, 
                                            :CDINSPECAO, 
                                            :CDHABILIDADE, 
                                            :CDEQUIPPRO, 
                                            :CDOPERADOR, 
                                            :IDRECURETAOP, 
                                            :NRRECURPAI, 
                                            :DTINIUTRECOP)";
            $params = array(
                'IDSITGRAVCONT'=>'P',
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$newNrrecuetapop,
                'NRORG'=>$row['NRORG'],
                'CDINSPECAO'=>$row['CDINSPECAO'],
                'CDHABILIDADE'=>$row['CDHABILIDADE'],
                'CDEQUIPPRO'=>$row['CDEQUIPPRO'],
                'CDOPERADOR'=>$row['CDOPERADOR'],
                'IDRECURETAOP'=>$row['IDRECURETAOP'],
                'NRRECURPAI'=>$nrpai,
                'DTINIUTRECOP'=>$row['SYSDATE']
            );
            $std = $this->connection->prepare($sql);
            $result = $std->execute($params);
            return $result;
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function searchChild($row){
        try {
            $sql = "SELECT * FROM RECURETAPAOP 
                        WHERE CDFILIAL     = :CDFILIAL 
                            AND NRAUDITORIA  = :NRAUDITORIA 
                            AND NRINSPECAUDI = :NRINSPECAUDI 
                            AND NRRECURPAI = :NRRECUETAPOP 
                            AND NRORG        = :NRORG
                            AND DTFINUTRECOP IS NULL";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
   
    public function searchLastCompleteChild($row){
        try {
            $sql = "SELECT * FROM RECURETAPAOP  
                    WHERE (NRRECUETAPOP = (SELECT MAX(NRRECUETAPOP) FROM RECURETAPAOP 
                          WHERE CDFILIAL     = :CDFILIAL 
                              AND NRAUDITORIA  = :NRAUDITORIA 
                              AND NRINSPECAUDI = :NRINSPECAUDI 
                              AND NRRECURPAI = :NRRECUETAPOP 
                              AND NRORG        = :NRORG
                              AND DTFINUTRECOP IS NOT NULL
                              AND DTINIUTRECOP  IS NOT NULL))
                      AND NRAUDITORIA  = :NRAUDITORIA 
                      AND NRINSPECAUDI = :NRINSPECAUDI 
                      AND NRRECURPAI = :NRRECUETAPOP ";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function lastIDJustificapausa($row){
        try {
            $sql = "SELECT MAX(CDJUSTIFICA) AS LASTID FROM JUSTIFICAPAUSA 
                      WHERE CDFILIAL     = :CDFILIAL 
                      AND NRAUDITORIA  = :NRAUDITORIA 
                      AND NRINSPECAUDI = :NRINSPECAUDI 
                      AND NRRECUETAPOP = :NRRECUETAPOP 
                      AND NRORG        = :NRORG";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            $result = $std->fetchAll();
            if($result[0]['LASTID'] == null){
                $result[0]['LASTID'] = "001";
                return $result;
            } else {
                $LASTID = (intval($result[0]['LASTID']) + 1);
                $zeros = '';
                $toString  = (string)$LASTID; 
                for($i=0; $i<(3-strlen($toString));$i++){
                   $zeros = $zeros.'0';
                }
                $LASTID = $zeros.(string)$LASTID;
                $result[0]['LASTID'] = $LASTID;
                
                return $result;
            }
    
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function sendJustificative($row){
        try {
            $sql = "INSERT INTO JUSTIFICAPAUSA 
                               (CDFILIAL, NRAUDITORIA, NRINSPECAUDI, NRRECUETAPOP, NRORG, CDOPERADOR, CDJUSTIFICA, DSJUSTIFICA, DTPAUSA)
                                    VALUES ( :CDFILIAL, 
                                            :NRAUDITORIA, 
                                            :NRINSPECAUDI, 
                                            :NRRECUETAPOP, 
                                            :NRORG, 
                                            :CDOPERADOR, 
                                            :CDJUSTIFICA, 
                                            :DSJUSTIFICA, 
                                            :DTPAUSA)";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG'],
                'CDOPERADOR'=>$row['CDOPERADOR'],
                'CDJUSTIFICA'=>$row['CDJUSTIFICA'],
                'DSJUSTIFICA'=>$row['DSJUSTIFICA'],
                'DTPAUSA'=>$row['DTPAUSA']
            );
            $std = $this->connection->prepare($sql);
            $result = $std->execute($params);
            return $result;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function existeNaTabela($row){
        try {
            $sql = "SELECT * FROM DESCINSAUDIT
                    WHERE CDFILIAL        = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function sendObservacaoInsert($row){
        try {
            $sql = "INSERT INTO DESCINSAUDIT 
                               (TXINSPECAUDI, TEMPINICIAL, TEMPFINAL, PESOINICIAL, PESOFINAL, 
                               CDFILIAL, NRAUDITORIA, NRINSPECAUDI)
                        VALUES (:TXINSPECAUDI, 
                                
                                :TEMPINICIAL,
                                :TEMPFINAL,
                                :PESOINICIAL,
                                :PESOFINAL,
                                
                                :CDFILIAL, 
                                :NRAUDITORIA, 
                                :NRINSPECAUDI)";
                     
            $params = array(
                'TXINSPECAUDI'=>$row['TXINSPECAUDI'],
                
                'TEMPINICIAL'=>$row['TEMPINICIAL'],
                'TEMPFINAL'=>$row['TEMPFINAL'],
                'PESOINICIAL'=>$row['PESOINICIAL'],
                'PESOFINAL'=>$row['PESOFINAL'],
                
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI']
            );
            $std = $this->connection->prepare($sql);
            $result = $std->execute($params);
            return $result;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function sendObservacaoUpdate($row){
        try {
            $sql = "UPDATE DESCINSAUDIT 
                        SET TXINSPECAUDI = :TXINSPECAUDI,
                        TEMPINICIAL = :TEMPINICIAL,
                        TEMPFINAL = :TEMPFINAL,
                        PESOINICIAL = :PESOINICIAL,
                        PESOFINAL = :PESOFINAL
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI";
                     
            $params = array(
                'TXINSPECAUDI'=>$row['TXINSPECAUDI'],
                
                'TEMPINICIAL'=>$row['TEMPINICIAL'],
                'TEMPFINAL'=>$row['TEMPFINAL'],
                'PESOINICIAL'=>$row['PESOINICIAL'],
                'PESOFINAL'=>$row['PESOFINAL'],
                
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI']
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
}

?>