<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

use Teknisa\CDP\Modules\Producao\Services\Cdp05000RoteiroProducaoService;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\CDP\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use \Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;

class Cdp05000RoteiroProducaoController extends TeknisaCrud {

    protected $environment;
    protected $entityManager;
    protected $Cdp05000RoteiroProducaoService;

    public function __construct($crudService, $parameterBag, $environment, $entityManager, $Cdp05000RoteiroProducaoService) {
        parent::__construct($crudService, $parameterBag);
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->Cdp05000RoteiroProducaoService = $Cdp05000RoteiroProducaoService;
    }

    public function roteiroDeleteFilhos(DTO\Request $request, DTO\Response $response) {
        try {
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            $row = $request->getRow();
            $this->Cdp05000RoteiroProducaoService->roteiroDeleteFilhos($row);
            $this->entityManager->commit();

        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
}