<?php

namespace Teknisa\CDP\Modules\Producao\Controllers;

use Teknisa\GER\Controllers\TeknisaCrud;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\GER\Controllers\CrudController;
use Teknisa\GER\Services\CrudService;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;

class Ger10700TipoDeVistoController extends TeknisaCrud {
        
    protected $dataSourceName;
        
    public function __construct($crudService,  ParameterBag $parameterBag) {
        parent::__construct($crudService, $parameterBag);
    }
    
    public function saveTpVisto(DTO\Request $request, DTO\Response $response) {
        $dataSourceName = 'grupoper_tipovisto';
        $row = $request->getRow();
        $conditions = array(
            array(
                "value" => $row["CDGRUPOPER"],
    	        "operator" => "=",
    	        "columnName" => "CDGRUPOPER"
            )
        );
        $filterCriteria = new FilterCriteria('grupoper_tipovisto', $conditions);
        
        try{
            try{
                $this->crudService->find($response, $filterCriteria);
            } catch(\Exception $e){
                throw $e;
            }
            
            $this->dataSourceName = $dataSourceName;
            if($response->getDataSets()[0]->getRows()) {
                $response->setError(new Error("", 500));
            }else{
                parent::save($request, $response);
            }
        }catch(\Exception $e) {
            if(!(count($response->getError()))) {
                $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            }
        }
    }
}