<?php
namespace Teknisa\CDP\Modules\Producao\Services;

use Doctrine\ORM\EntityManager;
use Geral\Util\DateUtil;
use Teknisa\Libs\Util\Environment;


class Cdp07700CalendarioDeProducaoService{

	protected $entityManager;
	protected $environment;
	protected $Cdp07700CalendarioDeProducaoFactory;

	public function __construct(Environment $environment, EntityManager $entityManager, $Cdp07700CalendarioDeProducaoFactory){
		$this->environment				= $environment;
		$this->entityManager           = $entityManager;
		$this->Cdp07700CalendarioDeProducaoFactory = $Cdp07700CalendarioDeProducaoFactory;
	}

	
    public function deleteCalendario($rows){
             
        try{
        	$connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            
            $rows['NRORG'] = $this->environment->getNrOrgTrab();
        	$this->Cdp07700CalendarioDeProducaoFactory->deleteCalendarioProducao($rows['NRORG'],$rows['CDFILIAL'],$rows['CDPERIPRODU'],$rows['ANODELETA']);
        	
        	$connection->commit();
        	
        }catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
        
        
    }
    
    public function deleteCalendarioMes($rows){
             
        try{
        	$connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            
            $rows['NRORG'] = $this->environment->getNrOrgTrab();
        	$this->Cdp07700CalendarioDeProducaoFactory->deleteCalendarioProducaoMes($rows['NRORG'],$rows['CDFILIAL'],$rows['CDPERIPRODU'],$rows['ANODELETA']);
        	
        	$connection->commit();
        	
        }catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
        
        
    }
    
    public function CalcularProducaoAnual($rows, $response) {
        $this->Cdp07700CalendarioDeProducaoFactory->CalculoProdAnual($rows, $response);
    }


}