<?php
namespace Teknisa\CDP\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode; 
use Teknisa\CDP\Factories\OpdigitalFactory;
use \Geral\Entities\Paramfilial;
use \Producao\Entities\Paraman;
//use Teknisa\PebLibs\Services\ValidacoesEstoqueService;

class OpdigitalService {
    
    protected $entityManager;
    protected $environment;
    protected $newCode;
    protected $OpdigitalFactory;
    protected $estoqueLibs;
    
    
    public function __construct(EntityManager $entityManager, Environment $environment, NewCode $newCode, $OpdigitalFactory, ValidacoesEstoqueService $estoqueLibs)
    {        
        $this->entityManager                    = $entityManager;
        $this->environment                      = $environment;
        $this->newCode                          = $newCode;
        $this->OpdigitalFactory                 = $OpdigitalFactory;   
        $this->estoqueLibs                      = $estoqueLibs;
    }
    
    public function resultValue($field){
        if (($field == '') || ($field == null)){
            return ' ';
        }else 
            return $field;
    }
    
    // Método para preencher as tabelas de lote previsto na abertura da tela de retirada
    public function preparaItensRetirada($row){  
        try {   
            
            // die;
            $row = $row[0];
            
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            // Verifica se a OP é para um produto Piloto
            $idprodpiloto = $this->OpdigitalFactory->xdqVerifProdPiloto($row);
            
            if($idprodpiloto){
                $stIdProdPil = 'S';
            }else{
                $stIdProdPil = 'N';
            }
            // Verifica se tem Retirada para a OP
            $itemRetiEst = $this->OpdigitalFactory->adqItemRetiEst($row);
            
            // Busca dados da OP
            $ordProducao = $this->OpdigitalFactory->adqOrdProducao($row);
            
            // Busca parametrizacao do CDP
            $paraMan = $this->OpdigitalFactory->adqParaMan($row['CDFILIAL']);
            
            $boNext = true;
            
            // Loop de Itens de Retirada - LOOP PRINCIPAL
            if($itemRetiEst){
                foreach($itemRetiEst as $itemReti) {
                    
                    $retiradaEsto = $this->OpdigitalFactory->adqRetiradaEsto($row, $itemReti['NRRETEST']);
                    
                    if(!$retiradaEsto && $itemReti['IDTIPOMOVI'] <> 'D'){
                        // Apaga os lotes para retirada
                        
                        $delLotItRetiEst = $this->OpdigitalFactory->acmDel_LotItRetiEst($itemReti['CDFILIAL'], 
                                                                                        $itemReti['NRRETEST'], 
                                                                                        $itemReti['NRSEQRETPROD'], 
                                                                                        $itemReti['CDPRODUTO']);
                        // Busca parametrizacao do insumo   
                        $insumetapa = $this->OpdigitalFactory->adqInsumetapa($row, 
                                                                            $itemReti['CDETAPAPROD'],
                                                                            $itemReti['CDPRODUTO']);
                        
                        // Se insumo não precisar de lote de compatibilidade
                        if(
                            ($ordProducao && $ordProducao[0]['IDVERIFCOMPAT'] == 'N') ||
                            ($ordProducao && $ordProducao[0]['IDVERIFCOMPAT'] == 'S' && $ordProducao[0]['IDCOMPATI'] == 'N')
                        ){
                            // Busca parametrizacao do insumo
                            $verifInsumos = $this->OpdigitalFactory->adqVerif_Insumos($row, 
                                                                                    $itemReti['CDETAPAPROD'], 
                                                                                    $itemReti['CDPRODUTO'], 
                                                                                    $itemReti['CDFILIAL']);
                            
                            $boAcabou = false;
                            $doQtRetiProd = $itemReti['QTPRERETPROD'];
                            $inCont = 1;
                            if($paraMan && $paraMan['IDTPRETIRADA']){
                                $idtpretirada = $paraMan['IDTPRETIRADA'];
                            }else{
                                $idtpretirada = 'FE';
                            }
                            
                            $qtretiprod = $doQtRetiProd;
                            
                            $estMatPrima = $this->OpdigitalFactory->adqEstMatPrima($row, 
                                                                                    $itemReti['CDPRODUTO'], 
                                                                                    $idtpretirada, 
                                                                                    $qtretiprod);

                            if(
                                ($verifInsumos && $estMatPrima &&
                                $verifInsumos[0]['IDSEMIACETAP'] == 'S' &&
                                $doQtRetiProd > $estMatPrima[0]['QTTOTALESTOQ'])
                            ){
                                
                                /*$ordProdPai = $this->OpdigitalFactory->adqOrdProdPai($row, 
                                                                                    $itemReti['CDPRODUTO']);

                                if(!$ordProdPai && !$row['NRSUBORDPROD']){
                                    
                                    // VERIFICAR COM JURANDIR. LINHA 2772 NO DELPHI
                                    // GeraOrdemProducao(Now, adqVerif_InsumosCDPRODINSUMO.AsString,
                                    // doQtRetiProd, '', stNrOrdProd, stNrOrdProd, '');
                                }*/
                            }
                            
                            if($verifInsumos && $verifInsumos[0]['IDSEMIACETAP'] == 'S'){
                                $estMatPrima = $this->OpdigitalFactory->adqEstMatPrima($row, 
                                                                                        $itemReti['CDPRODUTO'], 
                                                                                        $idtpretirada, 
                                                                                        $qtretiprod);
                            }
                            
                            $estMatPrimaFilter = [];
                            if($verifInsumos && $verifInsumos[0]['IDLOTEPRETAP'] == 'S'){
                                $estMatPrimaFilter = $this->OpdigitalFactory->adqEstMatPrimaFilter($row, 
                                                                                            $itemReti['CDPRODUTO'], 
                                                                                            $idtpretirada, 
                                                                                            $qtretiprod,
                                                                                            $ordProducao[0]['NRLOTEESTQ'],
                                                                                            $ordProducao[0]['NRSUBLOTE']);
                            }
                            
                            $estMatPrimaAux = $estMatPrima;
                            if($estMatPrimaFilter){
                                $estMatPrima = $estMatPrimaFilter;
                            }else{
                                $estMatPrima = $estMatPrimaAux;
                            }
                            
                            $tercProdProducao = [];
                            if($estMatPrima){
                                
                                foreach($estMatPrima as $itemEstMatPrima) {
                                    while(true){
                                        
                                        // Se é uma op para producao de um item do pedido de industrialização
                                        $tercProdProducao = $this->OpdigitalFactory->adqTercProdProducao($row, 
                                                                                                        $itemEstMatPrima['CDPRODUTO']);
                                        
                                        if($tercProdProducao && $tercProdProducao[0]['CDPRODUTO']){
                                            //verifica se há estoque do insumo especifico do terceiro
                                            $posTercProd = $this->OpdigitalFactory->adqPosTercProd($row, 
                                                                                                    $this->resultValue($itemEstMatPrima['CDPRODUTO']),
                                                                                                    $this->resultValue($itemEstMatPrima['CDALMOXARIFE']),
                                                                                                    $this->resultValue($itemEstMatPrima['CDLOCALESTOQ']),
                                                                                                    $this->resultValue($itemEstMatPrima['NRLOTEESTQ']),
                                                                                                    $this->resultValue($itemEstMatPrima['NRSUBLOTE']));
                                                         
                                            if($posTercProd && !$posTercProd[0]['CDPRODUTO']){
                                                $inCont = $inCont + 1;
                                                break;
                                            }
                                        }
                                        if($doQtRetiProd > 0){
                                            $prodFili = $this->OpdigitalFactory->adqProdFili($row['CDFILIAL'], 
                                                                                            $itemEstMatPrima['CDPRODUTO']);
                                            
                                            $doQtEstoqueTotal = $itemEstMatPrima['QTTOTALESTOQ'];
                                            
                                            if($prodFili['IDUTVRFTCONVVAR'] == 'S'){
                                                if(
                                                    $itemEstMatPrima['VRFATOCONV'] == 0||
                                                    $itemEstMatPrima['VRFATOCONV'] == 1||
                                                    !$itemEstMatPrima['VRFATOCONV']
                                                ){
                                                    $doTeor = 100;
                                                }else{
                                                    $doTeor = $itemEstMatPrima['VRFATOCONV'];
                                                }
                                                
                                                // JÁ FAÇO ESSE ADQ ANTES, VERIFICAR SE PRECISA MESMO
                                                /*$insumetapa = $this->OpdigitalFactory->adqInsumetapa($row, 
                                                                                                $itemReti['CDETAPAPROD'],
                                                                                                $itemReti['CDPRODUTO']);*/
                                                                                           
                                                if($doTeor <> 100){
                                                    if($insumetapa && $insumetapa[0]['VRFATOPADR'] == 0){
                                                        $doRetiradaAjustada = $doQtRetiProd;
                                                    }else{
                                                        $doRetiradaAjustada = (($doQtRetiProd * $doTeor)/$insumetapa[0]['VRFATOPADR']);
                                                    }
                                                }else{
                                                    $doRetiradaAjustada = $doQtRetiProd;
                                                }
                                            }else{
                                                // se o produto utiliza teor
                                                if($verifInsumos[0]['IDUTAPRREQET'] == 'S'){
                                                    if(
                                                        $itemEstMatPrima['VRAPROVPROD'] == 0 ||
                                                        $itemEstMatPrima['VRAPROVPROD'] == 1 ||
                                                        !$itemEstMatPrima['VRAPROVPROD']
                                                    ){
                                                        $doTeor = 100;
                                                    }else{
                                                        $doTeor = $itemEstMatPrima['VRAPROVPROD'];
                                                    }
                                                }else{
                                                    $doTeor = 100;
                                                }
                                                $doRetiradaAjustada = ($doQtRetiProd*100)/$doTeor;
                                            }
                                            
                                            
                                            //se o estoque é suficiente para a retirada
                                            if($doRetiradaAjustada <= $doQtEstoqueTotal){
                                                $doQtOriginal = $doQtRetiProd;
                                                $doQtRetiProd = 0;
                                            }else{
                                                if($verifInsumos[0]['IDLOTEUNICO'] <> 'S'){
                                                    //retira todo o estoque e calcula a qt retirada restante
                                                    $doRetiradaAjustada = $doQtEstoqueTotal;
                                                    if($prodFili['IDUTVRFTCONVVAR'] == 'S'){
                                                        if($doTeor <> 100){
                                                            if($insumetapa[0]['VRFATOPADR'] == 0){
                                                                $doQtOriginal = $doRetiradaAjustada;
                                                            }else{
                                                                $doQtOriginal = (($doRetiradaAjustada * $insumetapa[0]['VRFATOPADR'])/$doTeor);
                                                            }
                                                        }else{
                                                            $doQtOriginal = $doRetiradaAjustada;
                                                        }
                                                    }else{
                                                        $doQtOriginal = (($doRetiradaAjustada * $doTeor)/100);
                                                    }
                                                    $doQtRetiProd = $doQtRetiProd - $doQtOriginal;
                                                }else{
                                                    $boNext = false;
                                                }
                                            }
                                            
                                            if($boNext){
                                                // Se a função não retornar vazia o operador não tem acesso ao almoxarifado/local de estoque
                                                $stResult = false;
                                                /*$stResult =  AcessoOperadorEst($row['CDFILIAL'], 
                                                                                $row['CDOPERADOR'], 
                                                                                $itemEstMatPrima['CDALMOXARIFE'],
                                                                                $itemEstMatPrima['CDLOCALESTOQ');*/
                                                                                
                                                if(!$stResult){
                                                    $prodFili = $this->OpdigitalFactory->adqProdFili($row['CDFILIAL'], 
                                                                                                    $itemEstMatPrima['CDPRODUTO']);
                                                    
                                                    if($doTeor == 100){
                                                        $vraprovprodret = '';
                                                    }else{
                                                        $vraprovprodret = $doTeor;
                                                    }
                                                    
                                                    $insert = $this->OpdigitalFactory->acmIns_LotItRetEst($row, 
                                                                                                $nrretest = $itemReti['NRRETEST'],
                                                                                                $nrseqretprod = $itemReti['NRSEQRETPROD'],
                                                                                                $cdproduto = $itemEstMatPrima['CDPRODUTO'],
                                                                                                
                                                                                                $cdalmoxarife = $this->resultValue($itemEstMatPrima['CDALMOXARIFE']),
                                                                                                $cdlocalestoq = $this->resultValue($itemEstMatPrima['CDLOCALESTOQ']),
                                                                                                $nrloteestq = $this->resultValue($itemEstMatPrima['NRLOTEESTQ']),
                                                                                                $nrsublote = $this->resultValue($itemEstMatPrima['NRSUBLOTE']),
                                                                                                
                                                                                                $vraprovprodret,
                                                                                                
                                                                                                $nrseqretlote = '001',
                                                                                                $qtretprod = $doQtOriginal,
                                                                                                $qtretliqprod = $doRetiradaAjustada,
                                                                                                $qtrejretprod = $doRetiradaAjustada,
                                                                                                $dtlancretdev = date('d/m/Y')
                                                                                            );

                                                }else{
                                                    break;
                                                }
                                            }
                                        }
                                        break;
                                        // $inCont = $inCont + 1;
                                        // $boNext = true;
                                    }
                                }
                            }
                        }
                        // Fim se insumo não precisar de lote de compatibilidade
                    }
                    // Fim se tipo retirada for devolução
                }
                // Fim Foreach adqEstMatPrima
            }
            // Fim se tiver itemRetEst
            
            // var_dump('vou comitar retirada');
            $this->entityManager->commit();

        } catch(\Exception $e) {
            $this->entityManager->rollback();
	        throw $e;
        }
    }
    
    // Método para preencher as tabelas de produto previsto na abertura da tela de fechamento
    // DESENVOLVER
    public function preparaFechamento($row){
        try {
            // $connection = $this->entityManager->getConnection();
            // $connection->beginTransaction();
            
            // $this->getDadosTela($row);
            
            $this->geraProdAcab($row);
            
            // $this->entityManager->commit();

        } catch(\Exception $e) {
            // $this->entityManager->rollback();
	        throw $e;
        }
    }
    
    public function geraProdAcab($row){
        try {   
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            $row = $row[0];
            
            $stCdAlmox  = '';
            $stCdLocEst = '';
            
            $stpAprCustop = $this->OpdigitalFactory->stpAprCustop($row);
            
            $adqGrid = $this->OpdigitalFactory->adqGrid($row['CDFILIAL'], $row['NRORDPROD'], $row['NRSUBORDPROD']);
            
            if($row['IDSITORDPROD'] <> '3'){
                if(!isset($adqGrid[0])){
                    $newAdqGrid[0] = $adqGrid;
                    $adqGrid = $newAdqGrid;
                }
                
                foreach($adqGrid as $item){
                    
                    $this->OpdigitalFactory->acmDelProdAcab($item);
                    
                    $adqPesqAlmLocAcab = $this->OpdigitalFactory->adqPesqAlmLocAcab($item);
                    
                    $xQryUtSeg = $this->OpdigitalFactory->xQryUtSeg($item);
                    
                    $xqryAlmoxQuar = $this->OpdigitalFactory->xqryAlmoxQuar($item);
                    
                    $adqProdAcabTerc = $this->OpdigitalFactory->adqProdAcabTerc($item);
                    
                    $getParamfili = $this->OpdigitalFactory->adqParamfilial($item['CDFILIAL']);

                    if($getParamfili['IDUTILALMOX'] == 'S'){
                        if($xQryUtSeg[0]['IDUTSEGLIBLOTE'] == 'S'){
                            if($adqProdAcabTerc && $adqProdAcabTerc[0]['IDUTILALMOXTERC'] <> 'S'){
                                $stCdAlmox = $xqryAlmoxQuar[0]['CDALMOXQUAR'];
                            }else{
                                if(empty($adqProdAcabTerc[0]['CDALMOXARIFE'])){
                                    $stCdAlmox = $xqryAlmoxQuar[0]['CDALMOXQUAR'];
                                }else{
                                    $stCdAlmox = $adqProdAcabTerc[0]['CDALMOXARIFE'];
                                }
                            }
                        }else{
                            if($adqProdAcabTerc && $adqProdAcabTerc[0]['IDUTILALMOXTERC'] <> 'S'){
                                $stCdAlmox = $adqPesqAlmLocAcab[0]['CDALMOXPRACA'];
                            }else{
                                if(empty($adqProdAcabTerc[0]['CDALMOXTERCCLI'])){
                                    $stCdAlmox = $adqPesqAlmLocAcab[0]['CDALMOXPRACA'];
                                }else{
                                    $stCdAlmox = $adqProdAcabTerc[0]['CDALMOXTERCCLI'];
                                }
                            }
                        }
                    }else{
                        $stCdAlmox = '';
                    }
                    
                    if($getParamfili['IDUTILLCESTQ'] == 'S'){
                        if($xQryUtSeg[0]['IDUTSEGLIBLOTE'] == 'S'){
                            if($adqProdAcabTerc && $adqProdAcabTerc[0]['IDUTILALMOXTERC'] <> 'S'){
                                $stCdLocEst = $xqryAlmoxQuar[0]['CDLOCALQUAR'];
                            }else{
                                if(empty($adqProdAcabTerc[0]['CDLOCALESTOQ'])){
                                    $stCdLocEst = $xqryAlmoxQuar[0]['CDLOCALQUAR'];
                                }else{
                                    $stCdLocEst = $adqProdAcabTerc[0]['CDLOCALESTOQ'];
                                }
                            }
                        }else{
                            if($adqProdAcabTerc && $adqProdAcabTerc[0]['IDUTILALMOXTERC'] <> 'S'){
                                $stCdLocEst = $adqPesqAlmLocAcab[0]['CDLOCALPRACA'];
                            }else{
                                if(empty($adqProdAcabTerc[0]['CDLOCALTERCCLI'])){
                                    $stCdLocEst = $adqPesqAlmLocAcab[0]['CDLOCALPRACA'];
                                }else{
                                    $stCdLocEst = $adqProdAcabTerc[0]['CDLOCALTERCCLI'];
                                }
                            }
                        }
                    }else{
                        $stCdLocEst = '';
                    }
                    
                    // VERIFICAR CONDIÇÃO DO OPERADOR TER ACESSO AO ALMOXARIFADO
                    
                    $adqSeqProdAcab = $this->OpdigitalFactory->adqSeqProdAcab($item);
                    
                    if($adqSeqProdAcab[0]['NRPRODACAB'] == '000'){
                        
                        $acmInsProdAcab = $this->OpdigitalFactory->acmInsProdAcab(
                            $idatuprodaca = 'N',
                            $item['CDFILIAL'],
                            $item['NRORDPROD'],
                            $item['NRSUBORDPROD'],
                            $item['CDPRODUTO'],
                            $item['NRSUBPRETAOP'],
                            $item['CDPRODUTO'],
                            $nrprodacab = str_pad($adqSeqProdAcab[0]['NRPRODACAB']+1, 3 , "0", STR_PAD_LEFT),
                            $item['NRLOTEESTQ'],
                            $item['NRSUBLOTE'],
                            $stCdAlmox,
                            $stCdLocEst,
                            $item['CUSTOUNIT']
                        );
                        
                    }else{
                        $acmUpdProdAcab = $this->OpdigitalFactory->acmUpdProdAcab(
                            $item['CDFILIAL'],
                            $item['NRORDPROD'],
                            $item['NRSUBORDPROD'],
                            $item['CDPRODUTO'],
                            $item['NRSUBPRETAOP'],
                            $item['CUSTOUNIT']
                        );
                    }
                }
            }
            
            $this->entityManager->commit();
            
        } catch(\Exception $e) {
            $this->entityManager->rollback();
	        throw $e;
        }
    }
    
    public function getDadosTela($row){
        try {
            
        } catch(\Exception $e) {
            $this->entityManager->rollback();
	        throw $e;
        }
    }
    
    // Método para atualizar estoque na tela de retirada
    // DESENVOLVER
    public function atualizaEstoqueRetirada($rows){
        
        try {
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            #
            # INICIO ROTINA
            #
            
            $paramMan = $this->getParamman($rows[0]);
            
            $itemsReti = $rows;
            $itemsRetiAux = $rows;
            $stNrRetirada = '_';
            $arrayErro = array();
            
            $boTesteCompatibilidade = False; // Variável para verificar se o teste de compatibilidade já foi realizado
            foreach($rows as $row){
                $stNrRetirada = $stNrRetirada.$row['NRRETEST'].'_';
            }
            
            foreach($rows as $row){
                // Verifica se o produto é a água parametrizada e o atualiza como baixado
                
                if($row['IDPRODAGUA'] == 'S'){
                    # Manipulação de banco 1
                    $this->OpdigitalFactory->updateRetiradaAgua($row['CDFILIAL'], 
                                                                $row['NRRETEST']);
                }else{
                    //VALIDA A QUANTIDADE DE LOTES POR RETIRADA
                    //$paramMaf = $this->OpdigitalFactory->adqParamMaf($row['CDFILIAL']); //no delphi faz este select mas nao usa pra nada
                    $procFabrica = $this->OpdigitalFactory->adqProcFabrica($row['CDFILIAL'], 
                                                                        $row['NRORDPROD'],
                                                                        $row['NRSUBORDPROD']);
                                                                        
                    $adqLoteUnico = $this->OpdigitalFactory->adqLoteUnico($row['CDFILIAL'], 
                                                                        $procFabrica['CDPRODUTO'], 
                                                                        $procFabrica['CDPROCFABRIC'], 
                                                                        $row['CDETAPAPROD'], 
                                                                        $row['CDPRODUTO']);
                    
                    if($adqLoteUnico && $adqLoteUnico['IDLOTEUNICO'] == 'S'){
                        $vDQtdeLote = $this->OpdigitalFactory->adqVDQtdeLote($row['CDFILIAL'], $row['CDPRODUTO'], $row['NRORDPROD'], $row['NRSUBORDPROD']);
                    }
                    if(isset($vDQtdeLote)){
                        $nomeProd = $this->OpdigitalFactory->xqryNomeProd($row['CDPRODUTO']);
                        array_push($arrayErro, $nomeProd+' - Não é permitida a retirada de mais de 1 lote diferente por produto.');
                    }
                    
                    // Verifica se deve ser realizado o teste de compatibilidade dos insumos
                    if($procFabrica['IDVERIFCOMPAT'] == 'S' && !boTesteCompatibilidade){
                        var_dump('IDVERIFCOMPAT é S este treixo de codigo ainda nao foi validado');
                        // Verifica se todos os insumos que precisam de compatibilidade estão sendo retirados juntos
                        $insumoComp = $this->OpdigitalFactory->adqInsumoComp($row['CDFILIAL'], $row['CDPROCFABRIC'], $row['CDPRODUTO']);
                        
                        $inCont = 0;
                        $filteredItems = array_filter($itemsRetiAux, function($row){
                            return $row['CDPRODUTO'] == $insumoComp['CDPRODUTO'] && $row['CDFILIAL'] == $insumoComp['CDFILIAL'];
                        }); 
                        foreach($filteredItems as $row){
                            if(is_null($row['NRLANCESTQ'])){
                                $row['IDCHECK'] == 'N' ? $inCont++ : false;
                            }
                        }
                        
                        // Se a variável inCont = adqInsumoComp.RecordCount é porque nenhum insumo de compatibilidade está sendo retirado
                        if($inCont > 0 && $inCont != count($insumoComp)){
                            array_push($arrayErro, 'Os insumos que fazem teste de compatibilidade devem ser retirados juntos.');
                             //GravaErro('Os insumos que fazem teste de compatibilidade devem ser retirados juntos.');
                        }
                        if ($inCont <>  count($insumoComp) && count($arrayErro == 0)){
                            // Busca os insumos compatibilidade e os lotes que foram ou estão sendo retirados
                            $lotesRetComp = $this->OpdigitalFactory->adqLotesRetComp($row['CDFILIAL'], $row['NRORDPROD'], $row['NRSUBORDPROD'], $row['CDPRODUTO']);
                            // Se nenhum insumo estiver marcado para realizar compatibilidade, a retirada é feita normalmente
                            if(!is_null($lotesRetComp)){
                                // Varável para verificar se o teste de compatibilidade está ok
                                $boCompatOk = false;
                                $stCdInsumoComp = '';
                                $stNrLote = '';
                                foreach($lotesRetComp as $row){
                                    $stCdInsumoComp = $stCdInsumoComp.'_'.$row['CDPRODUTO'];
                                    $stNrLote = $stNrLote.'_'.$row['NRLOTEESTQ'];
                                }
                                
                                // Busca as possíveis análises de compatibilidade
                                $analisesComp = $this->OpdigitalFactory->adqAnalisesComp($row['CDFILIAL'], $row['CDPROCFABRIC'], $row['CDPRODUTO'], $row['CDPRODINSUMO'], $row['NRLOTEESTQ']);
                                
                                // Se não existir análise de compatibilidade, mensagem é retornada a cliente
                                if(is_null($analisesComp)){
                                    array_push($arryErro,  'Operação bloqueada. Verifique se existe Teste de Compatibilidade realizado entre os lotes.');
                                }else{
                                    foreach($analisesComp as $row){
                                        if(!$boCompatOk){
                                            break;
                                        }
                                        $boAnaOk = true; // Var que controla se os produtos e lotes estão ok
                                        $lotesCompativeis = $this->OpdigitalFactory->adqLotesCompativeis($row['CDFILIAL'], $row['CDPROCFABRIC'], $row['CDPRODUTO'], $row['CDPRODINSUMO'], $row['NRLOTEESTQ'], $row['NRAUDITORIA']);
                                        
                                        // Enquanto o teste der errado
                                        $filteredLotes = array_filter($lotesCompativeis, function($rowLote){
                                            return $rowLote['CDPRODINSUMO'] == $row['CDPRODUTO'] && 
                                                    $rowLote['NRLOTEESTQ'] == $row['NRLOTEESTQ'] &&
                                                    $rowLote['NRSUBLOTE'] == $row['NRSUBLOTE'];
                                        });
                                        if(count($filteredLotes) == 0)
                                            $boAnaOk = false;
                                        else
                                            $boAnaOk = true;
                                            
                                        if($boAnaOk)
                                            $boCompatOk = true;
                                        if(!$boCompatOk)
                                            array_push($arrayErro, 'Operação bloqueada. Verifique se existe Teste de Compatibilidade realizado entre os lotes.');
                                    }
                                }
                            }
                        }
                        $boTesteCompatibilidade = true;
                    }
                    
                    $lotesRetDev = $this->OpdigitalFactory->adqLotesRetDev($row['CDFILIAL'], $row['CDPRODUTO'], $stNrRetirada);

                    foreach($lotesRetDev as $rowRetDev){    
                        if(!is_null($rowRetDev['NRLOTEESTQ'])){
                            // Caso seja uma devolucao
                            if($rowRetDev['IDTPRETEST'] == 'D'){
                                $vdMov = $this->OpdigitalFactory->adqVdMov($row['CDFILIAL'], $row['CDPRODUTO'], $row['NRORDPROD'], $row['NRSUBORDPROD']);
                                if(!is_null($vdMov) && $vdMov['QTSALDO'] > 0)
                                    array_push($arrayErro, $vdMov['NMPRODUTO'].' - Quantidade devolvida deve ser menor ou igual a quantidade retirada.');
                            }
                        }
                        if($this->getParamfili($row)['IDUTILLOTE'] == 'S'){
                            $prodFili = $this->OpdigitalFactory->adqProdFili($row['CDFILIAL'],
                                                                            $row['CDPRODUTO']);
                                                                            
                            if($prodFili['IDUTCTRLLOTE'] == 'S'){
                                $infoProd = $this->OpdigitalFactory->qryInfoProd($row['CDFILIAL'],
                                                                                $row['CDPRODUTO'],
                                                                                $rowRetDev['NRLOTEESTQ'],
                                                                                $rowRetDev['NRSUBLOTE']);
                                                                                
                                //Busca a maior auditoria que existir do tipo análise
                                $maxAudit = $this->OpdigitalFactory->adqMaxAudit($row['CDFILIAL'], 
                                                                                $row['CDPRODUTO'], 
                                                                                $rowRetDev['NRLOTEESTQ'], 
                                                                                $rowRetDev['NRSUBLOTE']);
                                                                                
                                if(!is_null($infoProd)){
                                    
                                    // Se não existir análise, não faz as seguintes consistências
                                    
                                    if(!is_null($infoProd) && strtotime($infoProd['DTVALILOTE']) < strtotime(date('m/d/Y'))){
                                        
                                        $mensagem = 'Produto '.$row['CDPRODUTO'].
                                                    ' com data de validade vencida em '.$infoProd['DTVALILOTE'].'.'.
                                                    ' Lote: '.$rowRetDev['NRLOTEESTQ'];
                                        array_push($arrayErro, $mensagem);
                                    }else{
                                        if($paramMan['IDVALANARETPROD'] == 'S'){
                                            // Se não existir análise, não faz as seguintes consistências
                                            $reanalisePen = $this->OpdigitalFactory->adqReanalisePen($row['CDFILIAL'], 
                                                                                                    $row['CDPRODUTO'], 
                                                                                                    $rowRetDev['NRLOTEESTQ'], 
                                                                                                    $rowRetDev['NRSUBLOTE']);
                                            
                                            if(!empty($reanalisePen)){
                                                array_push($arrayErro, $infoProd['NMPRODUTO'].' cuja análise não está concluída ok. Análise '.$reanalisePen['NRAUDITORIA'].' com análise vencida em '.$infoProd['NRLOTEESTQ']);
                                            }else{
                                                
                                                if($maxAudit && !is_null($maxAudit['DTVALANA'])){
                                                    if($maxAudit['DTVALANA'] < date('d/m/Y')){
                                                        array_push($arrayErro, $infoProd['NMPRODUTO'].' com análise vencida em '.$maxAudit['DTVALANA'].' Lote '.$infoProd['NRLOTEESTQ']);
                                                    }else{
                                                        // Verifica se o produto possui análise/auditoria liberada, lembrando que não precisa estar concluída nesse momento.
                                                        if(!is_null($maxAudit['IDLIBERAUDIT']) && $maxAudit['IDLIBERAUDIT'] != 'S'){
                                                            array_push($arrayErro, 'A análise do produto '.$infoProd['NMPRODUTO'].' Lote '.$infoProd['NRLOTEESTQ'].' não foi liberada.');
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            
            //loop para eliminar registros duplicados
            //Correção para retiradas duplicadas. Sol.127713 Risotolandia -}   
            
            if(empty($arrayErro)){
                
                $stVdRetDuplica = '';
                for($i = 0 ; $i< count($itemsReti) ; $i ++){
                    if($itemsReti[$i]['NRRETEST'] == $stVdRetDuplica )
                        array_slice($itemsReti, $i, 1);
                    
                    $stVdRetDuplica = $itemsReti[$i]['NRRETEST'];
                }
                
                foreach($itemsReti as $itemReti){
                    
                    if($itemReti['IDPRODAGUA'] != 'S'){

                        $operador = $this->environment->getCdOperador();
                        $stNrLancToEst = $this->newCode->getCodeByTableName('LANCTOEST'.$itemReti['CDFILIAL'], $this->environment->getNrOrgTrab());//novocodigo lancto est aqui
                        $itemReti['NRLANCTOEST'] = $stNrLancToEst;
                        
                        $msgPadrao = 'Lanc. referente à OP '.$itemReti['NRORDPROD'].'\\'.$itemReti['NRSUBORDPROD'].' App Inspeção.';
                        
                        # Manipulação de banco 2
                        $this->OpdigitalFactory->insertLanctoestoq($itemReti['CDFILIAL'], 
                                                                    $stNrLancToEst, 
                                                                    date('d/m/Y'), 
                                                                    '3', 
                                                                    'S', 
                                                                    'S', 
                                                                    $itemReti['CDFILIAL'], 
                                                                    $operador, 
                                                                    $msgPadrao);
                                                  
                        # Manipulação de banco 3
                        $this->OpdigitalFactory->updtNrlanEstqRetiesto($itemReti['CDFILIAL'], 
                                                                        $stNrLancToEst, 
                                                                        $itemReti['CDFILIAL'], 
                                                                        $itemReti['NRRETEST']);
                                                                        
                        $verifItemRetiEst = $this->OpdigitalFactory->verifItemRetiEst($itemReti['CDFILIAL'], 
                                                                                        $itemReti['NRRETEST'], 
                                                                                        $itemReti['CDPRODUTO']);
                
                        foreach($verifItemRetiEst as $itemVeri){
                            
                            if($itemVeri['IDTPRETEST'] == 'D'){
                                $P_IDENTRSAIDOP = 'E';
                                $P_IDTIPOMOVI = '2';
                                $P_IDORDEMCLC = '2';
                            }else{
                                $P_IDENTRSAIDOP = 'S';
                                $P_IDTIPOMOVI = '3';
                                $P_IDORDEMCLC = '9';
                            }
                            
                            //solicitação 163982
                            # Manipulação de banco 4
                            $this->OpdigitalFactory->updtDtLanctoEstoq($itemReti['CDFILIAL'], 
                                                                        $stNrLancToEst, 
                                                                        $itemVeri['DTLANCRETDEV']);
                                                                        
                            $seqItem = $this->OpdigitalFactory->adqSeqItemLanc($itemReti['CDFILIAL'], 
                                                                                $stNrLancToEst);
                            
                            $dtReferencia = $this->OpdigitalFactory->adqParamGeral()['IDUTILDTPROC'] == 'S' ? $this->getParamfili($itemVeri)['DTPROCESSA'] : date('d/m/Y');
                            
                            $custo = $this->OpdigitalFactory->getCustoProdutoLcest($itemReti['CDFILIAL'], 
                                                                                    $itemVeri['CDPRODUTO'], 
                                                                                    '3', 
                                                                                    $itemVeri['DTLANCRETDEV'], 
                                                                                    $dtReferencia, 
                                                                                    $itemVeri['CDALMOXARIFE'], 
                                                                                    $itemVeri['CDLOCALESTOQ'], 
                                                                                    $itemVeri['NRLOTEESTQ'], 
                                                                                    $itemVeri['NRSUBLOTE']);
                            
                            $vrtotlancto = $itemVeri['QTRETLIQPROD'] * $custo;
                            
                            # Manipulação de banco 5
                            $this->OpdigitalFactory->insertItLancToEstReti(
                                                                        $cdfilial       = $itemVeri['CDFILIAL'],
                                                                        $stnrlanctoest  = $stNrLancToEst,
                                                                        $nrseqitem      = str_pad($seqItem, 4 , "0", STR_PAD_LEFT),
                                                                        $cdproduto      = $itemVeri['CDPRODUTO'],
                                                                        $qtlanctoest    = round($itemVeri['QTRETLIQPROD'], 6),
                                                                        $qttotlancto    = round($itemVeri['QTRETLIQPROD'], 6),
                                                                        $cdprodmovi     = $itemVeri['CDPRODUTO'],
                                                                        $cdfilimovi     = $itemVeri['CDFILIAL'],
                                                                        $cdalmoxarife   = $this->resultValue($itemVeri['CDALMOXARIFE']),
                                                                        $cdlocalestoq   = $this->resultValue($itemVeri['CDLOCALESTOQ']),
                                                                        $nrloteestq     = $this->resultValue($itemVeri['NRLOTEESTQ']),
                                                                        $nrsublote      = $this->resultValue($itemVeri['NRSUBLOTE']),
                                                                        $identrsaidop   = $P_IDENTRSAIDOP,
                                                                        $idtipomovi     = $P_IDTIPOMOVI,
                                                                        $cdtiporeti     = $itemVeri['CDTIPORETI'],
                                                                        $cdcentcust     = $itemVeri['CDCENTCUST'],
                                                                        $dtlancmovi     = $itemVeri['DTLANCRETDEV'],
                                                                        $vrunilancto    = $custo,
                                                                        $vrtotlancto    = $itemVeri['QTRETLIQPROD'] * $custo,
                                                                        $vrlanctoest    = $custo,
                                                                        $vrlanctobrut   = $custo,
                                                                        $idordemclc     = $P_IDORDEMCLC);
                            
                            # Manipulação de banco 6
                            $this->OpdigitalFactory->updtLotItRetiEst($stNrLancToEst,
                                                                        str_pad($seqItem, 4 , "0", STR_PAD_LEFT),
                                                                        $cdfilial,
                                                                        $itemVeri['NRRETEST'],
                                                                        $itemVeri['NRSEQRETPROD'],
                                                                        $itemVeri['CDPRODUTO'],
                                                                        $this->resultValue($itemVeri['NRLOTEESTQ']),
                                                                        $this->resultValue($itemVeri['NRSUBLOTE']),
                                                                        $this->resultValue($itemVeri['CDALMOXARIFE']),
                                                                        $this->resultValue($itemVeri['CDLOCALESTOQ']),
                                                                        $itemVeri['NRSEQRETLOTE']);
                            
                            // Atualiza a perda com o lote que realmente foi movimentado.
                            # Manipulação de banco 7
                            $this->OpdigitalFactory->updtAtuLotePerda($this->resultValue($itemVeri['NRLOTEESTQ']),
                                                                        $this->resultValue($itemVeri['NRSUBLOTE']),
                                                                        $cdfilial,
                                                                        $itemVeri['NRRETEST'],
                                                                        $itemVeri['NRSEQRETPROD']);
                        }
                        // Atualiza estoque

                        $this->estoqueLibs->atualizaEstoque($itemReti['CDFILIAL'], 
                                                            $stNrLancToEst);
                                                            
                        $irregularProducts = $this->estoqueLibs->getIrregularProducts();
                        
                        if(!empty($irregularProducts)){
                            $arrayErro['PRODIRREGULAR'] = $irregularProducts;
                        }
                    }
                }
            }else{
                $this->entityManager->rollback();
                return $arrayErro;
            }
            
            #
            # FIM ROTINA
            #
            
            $connection->commit();
            return $arrayErro;
        } catch(\Exception $e) {
            $this->entityManager->rollback();
	        throw $e;
        }
    }
    
    public function getParamman($row){
        return $this->OpdigitalFactory->adqParaman($row['CDFILIAL']);
    }
    
    public function getParamfili($row){
        return $this->OpdigitalFactory->adqParamfilial($row['CDFILIAL']);
    }
    
    public function getVdEvolEstq($row){
        return $this->OpdigitalFactory->getVdEvolEstq($row['CDFILIAL'], $row['NRORDPROD'], $row['NRSUBORDPROD']);
    }
    
    public function getInsuPrev($row){
        return $this->OpdigitalFactory->adqInsuPrev($row['CDFILIAL'], $row['NRORDPROD'], $row['NRSUBORDPROD']);
    }
    
    // Método para fechar a op
    // DESENVOLVER
    const RETIRADA          = "Não foi possivel fazer a retirada dos insumos da ordem de produção, a atualização de estoque de alguns produtos faria com que a posição de estoque se tornasse irregular";
    const ERRO_OP           = "Existem inconsistências na OP que não permitem que as informações desta tela sejam geradas.";
    const DtFabr_Deve       = "Não poderá ser feito fechamento sem data de fabricação para o produto.";
    const Irreg_Prod_Est    = "A atualização de estoque de alguns produtos faria com que a posição de estoque se tornasse irregular.";
    // const MSG_2             = "MSG2";
    const MSG_3             = "Produto sem atualização de estoque.";
    const MSG_4             = "Atividades";
    const MSG_5             = "Tarefa não concluída.";
    const MSG_9             = "Entrada";
    const MSG_10            = "Data entrada (dt. fabricação) deve ser menor ou igual a data de processamento.";
    const MSG_11            = "Data entrada (dt. fabricação) deve ser maior ou igual a data de processamento.";
    const MSG_12            = "Data entrada (dt. fabricação) fora do período permitido.";
    
    public function fechaOp($rows, $idresp = 'P'){
        try {
            
            // var_dump(get_class_methods($this->environment));die;
            
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            $allError = array();
            $arrayErros = array();
            $arrayAnalise = array();
            
            $irregEstoq = array();              //Retorna erros de irregularidade de estoque na retirada automatica de OP CONSOLIDADA
                                                //        erros de não ser possível listar os itens a serem produzidos
                                                //        erros se não for possível listar os produtos acabados a serem produzidos
                                                //        erros se não foi informada a quantidade produzida
            $erroProdSemBaixa = array();        //Retorna erros de produtos sem baixa de estoque
                                                //                 Bloqueia fechamento da OP sem a retirada de todos os insumos previstos
                                                //                 etapas obrigatórias com TAREFAS OU INSPEÇÃO OU ANALISES pendente ou em andamento
                                                //                                         ANALISES Concluida nao ok
                                                //                 se o custo de produção estiver zerado
                                                //                 dt. fabricacao fora do periodo permitido com relação a movimentação de estoque diferente da data de processamento
            $analisesPend = array();            // Analises pendentes ou em andamento ou concluída nao ok
            $produtosFechados = array();        // Retorno o cds de produtos fechados, caso tenha retornado erro de analise e ainda assim queira se fechar a op
            $perguntaQuantidadeDif = array();   //Emite pergunta para confirmar o fechamento sempre que a qt. produzida é maior que a prevista
            $desconhecido5 = array();           //
            
            $row = $rows[0];
            
            $paramEstoq = $this->OpdigitalFactory->adqParamEstoque();
            $paraMan = $this->OpdigitalFactory->adqParaman($row['CDFILIAL']);
            $paramFili = $this->OpdigitalFactory->adqParamfilial($row['CDFILIAL']); //xqryParam
            $paramMaf = $this->OpdigitalFactory->adqParamMaf($row['CDFILIAL']);
            
            $dataproc = $this->OpdigitalFactory->adqParamfilial($row['CDFILIAL'])['DTPROCESSA'];
            
            $row = json_decode(json_encode($row), true);
            
            $cdfilial       = $row['CDFILIAL'];
            $nrordprod      = $row['NRORDPROD'];
            $nrsubordprod   = $row['NRSUBORDPROD'];
            
            //Rotina de fechamento de OP

            //Se houve erro de irregularidade de estoque na Retirada automatica de insumos
            if(!empty($arrayErros)){
                array_push($irregEstoq, self::RETIRADA);
                $allError['irregEstoq'] = $irregEstoq;
                
                $connection->rollback();

                return $allError;
            }else{
                
                $grid = $this->getGrid($row['CDFILIAL'], 
                                    $row['NRORDPROD'], 
                                    $row['NRSUBORDPROD'], 
                                    'N');
                                    
                
                if(empty($grid)){
                    array_push($irregEstoq, self::ERRO_OP);
                    $allError['irregEstoq'] = $irregEstoq;
                    
                    $connection->rollback();
                    
                    return $allError;
                }
                
                //Recebe os dados informados pelo usuário referente aos itens produzidos
                $prodAcabado = $rows;
                
                if(!isset($grid[0])){
                    $newAdqGrid[0] = $grid;
                    $grid = $newAdqGrid;
                }
                
                foreach($grid as $gridRow){
                    $qtLote = 0;
                    if(empty($gridRow['DTFABRPROD'])){

                        //Retorna erro se o lote a ser produzido não possuir data de fabricação
                        array_push($irregEstoq, self::DtFabr_Deve);
                        $allError['irregEstoq'] = $irregEstoq;
                        
                        $connection->rollback();
                    
                        return $allError;
                    }else{
                        //Filtra o produto previsto no cds de produtos produzidos retornados pelo usuário
                        $prodAcabadoFilter = array_filter($prodAcabado, function($row) use($gridRow){
                            return $row['NRORDPROD']    == $gridRow['NRORDPROD'] 
                                && $row['NRSUBORDPROD'] == $gridRow['NRSUBORDPROD'] 
                                && $row['NRSUBPRETAOP'] == $gridRow['NRSUBPRETAOP'];
                        });
                        
                        if(empty($prodAcabadoFilter)){
                            //Não entendi o porque desse get <--- comentario do delphi
                            $prodAcabadoFilter = $this->OpdigitalFactory->adqProdAcab($prodAcabado['CDFILIAL'],
                                                                                    $prodAcabado['NRTIPOCUSTO'],
                                                                                    $prodAcabado['NRORDPROD'],
                                                                                    $prodAcabado['NRSUBORDPROD'], 
                                                                                    $gridRow['CDSUBPRODETA'], 
                                                                                    $gridRow['NRSUBPRETAOP']);
                        }
                        
                        $dados = array();
                        
                        foreach($prodAcabadoFilter as $prodAcab){
                            if($prodAcab['CDFILIAL']     == $gridRow['CDFILIAL']
                            && $prodAcab['NRORDPROD']    == $gridRow['NRORDPROD']
                            && $prodAcab['NRSUBORDPROD'] == $gridRow['NRSUBORDPROD']
                            && $prodAcab['CDSUBPRODETA'] == $gridRow['CDPRODUTO']
                            && $prodAcab['NRSUBPRETAOP'] == $gridRow['NRSUBPRETAOP']){
                                //verificar nacessidade do round 5 casas no QTPRODACABADO
                                $this->OpdigitalFactory->atuProdAcab(round($prodAcab['QTPRACABADO'], 5), 
                                                                    $prodAcab['CDFILIAL'], 
                                                                    $prodAcab['NRORDPROD'], 
                                                                    $prodAcab['NRSUBORDPROD'], 
                                                                    $prodAcab['CDSUBPRODETA'], 
                                                                    $prodAcab['NRSUBPRETAOP'], 
                                                                    $prodAcab['CDPRODUTO'], 
                                                                    $prodAcab['NRPRODACAB']);
                                                                    
                                $dadosRow = $prodAcab;
                                
                                $dadosRow['QTPRODLOTE'] = round($prodAcab['QTPRACABADO'], 5);
                                $dadosRow['CUSTOTOTAL'] = $gridRow['CUSTOTOTAL'];
                                $dadosRow['DTFABRPROD'] = $gridRow['DTFABRPROD'];
                                
                                $dadosRow['CUSTOTOT'] = $this->calculaTotProdAcab($gridRow, $prodAcab, $paramMaf);
                                $dadosRow['CUSTTOTLOTE'] = $dadosRow['CUSTOTOT'];
                                
                                array_push($dados, $dadosRow);
                                //Atualiza a quantidade total produzida do lote (Fechamento de op que já foi fechada parcialmente)
                                $qtLote = $qtLote + ($prodAcab['QTPRACABADO'] * $prodAcab['VRFATOCONVPR']);
                            }
                        }
                    }
                    
                    if(empty($dados)){
                        //Se não for possível listar os produtos acabados a serem produzidos emite msg de erro
                        array_push($arrayErros, 'ProdAcab_NCad');
                        //aqui adicionar erros ao response
                        $connection->rollback();
                        break;
                    }
                    
                    $qtLote = round($qtLote, 5);
                    
                    if($qtLote == 0){
                        //Se não foi informada a quantidade produzida emite erro
                        array_push($irregEstoq, 'QtAcab_Inf');
                        $connection->rollback();
                        break;
                    }
                    
                    //Emite pergunta ao usuário sempre que a qt. produzida é superior a qt. prevista para confirmar o fechamento
                    
                    if($qtLote > round($gridRow['QTPRODLOTE'], 3) && $qtLote != 0){
                        //Essa é a primeira vez que a rotina passa aqui, o valor da resposta será considerado a segunda vez que ele passar aqui
                        //A resposta será para todos os produtos da OP a ser fechada
                        if($idresp == 'P'){
                            array_push($erroProdSemBaixa, 'PERGUNTA'); // oleResult[4] := 'PERGUNTA';
                            $connection->rollback();
                            break;
                        }
                    }
                } // fim foreach($grid as $gridRow)
                
                // Rotina de Consistencias
                $retirada = $this->OpdigitalFactory->adqRetirada($row['CDFILIAL'], 
                                                                $row['NRORDPROD'], 
                                                                $row['NRSUBORDPROD']);  
                
                $stPri       = 'S';
                $stAnaPen    = 'N';
                $stOutrasPen = 'N';
                
                foreach($retirada as $rowRetirada){
                    if($stPri == 'S'){
                        // array_push($arrayErros, 'MSG_2');
                        $stPri = 'N';
                    }
                    
                    $mensagem = $rowRetirada['CDARVPROD'].' '.$rowRetirada['NMPRODUTO'].' - '.self::MSG_3;
                    array_push($arrayErros, $mensagem);
                    //Grava_Erro('  ' + adqRetirada.fieldByName('CDARVPROD').DisplayText + '  ' + adqRetirada.fieldByName('NMPRODUTO').AsString + ' - ' + MSG_3);
                    $stOutrasPen = 'S';
                }
                 
                //Bloqueia fechamento da OP sem a retirada de todos os insumos previstos
                if($paraMan && $paraMan['IDBLOQFECHA'] == 'S'){
                    //Lista os insumos previstos menos que nao estao na op
                    $minus = $this->OpdigitalFactory->adqMinus($row['CDFILIAL'], 
                                                                $row['NRORDPROD'], 
                                                                $row['NRSUBORDPROD']);
                                                                
                    foreach($minus as $minusRow){
                        //Verifica se não foi usado um produto substitudo
                        $prodSubs = $this->OpdigitalFactory->adqProdSubs($minusRow['CDPRODUTO']);
                        
                        // if(!isset($prodSubs[0])){
                        //     $newprodSubs[0] = $prodSubs;
                        //     $prodSubs = $newprodSubs;
                        // }
                        
                        if(!empty($prodSubs)){
                            
                            $retiradaProd = $this->OpdigitalFactory->adqRetiradaProd($row['NRORDPROD'], 
                                                                                    $row['CDFILIAL'], 
                                                                                    $row['NRSUBORDPROD']);
                            
                            if(!isset($retiradaProd[0])){
                                $newretiradaProd[0] = $retiradaProd;
                                $retiradaProd = $newretiradaProd;
                            }
                            
                            $boProdSubs = false;
                            foreach($prodSubs as $prodSubsRow){
                                $boProdSubs = $this->array_some($retiradaProd, function($retiProdRow) use($prodSubsRow){
                                    return $retiProdRow['CDPRODUTO'] == $prodSubsRow['CDPRODUTO'];
                                });
                                
                            }
                            
                            if(!$boProdSubs){
                                if($stPri == 'S'){
                                    // array_push($arrayErros, self::MSG_2);
                                    //Grava_Erro(MSG_2);
                                    $stPri = 'N';
                                }
                                
                                $mensagem = $minusRow['CDARVPROD'].' '.$minusRow['NMPRODUTO'].' - '.self::MSG_3;
                                array_push($arrayErros, $mensagem);
                                
                                //Grava_Erro('  ' + adqMinus.fieldByName('CDARVPROD').DisplayText + '  ' + adqMinus.fieldByName('NMPRODUTO').AsString + ' - ' + MSG_3);
                                $stOutrasPen = 'S';
                            }
                        }else{
                            if($stPri == 'S'){
                                // array_push($arrayErros, 'erro abaixo 2');
                                //Grava_Erro(MSG_2); 
                                $stPri = 'N';
                            }
                            
                            $mensagem = $minusRow['CDARVPROD'].' '.$minusRow['NMPRODUTO'].' - '.self::MSG_3;
                            array_push($arrayErros, $mensagem);
                            
                            //Grava_Erro('  ' + adqMinus.fieldByName('CDARVPROD').DisplayText + '  ' + adqMinus.fieldByName('NMPRODUTO').AsString + ' - ' + MSG_3);
                            $stOutrasPen = 'S';
                        }
                    }
                }
                    
                //with adqAtividade do begin
                $atividades = $this->OpdigitalFactory->adqAtividade($row['CDFILIAL'], 
                                                                    $row['NRORDPROD'], 
                                                                    $row['NRSUBORDPROD']);
                                                                    
                if($atividades && !isset($atividades[0])){
                    $newatividades[0] = $atividades;
                    $atividades = $newatividades;
                }
                
                foreach($atividades as $atividadeRow){
            
                    if($atividadeRow['IDORIGINSPEC'] == 'TAR'){
                        if($atividadeRow['IDPENAND'] == '1' || ($atividadeRow['IDPENAND'] == '2' && $atividadeRow['IDTPCONCLETAPA'] == 'S')){
                            if($stPri == 'S'){
                                // array_push($arrayErros, self::MSG_4);
                                $stPri = 'N';
                            }
                            $mensagem = $atividadeRow['CDARVINSPEC'].' '.$atividadeRow['NMINSPECAO'].' - '.self::MSG_5;
                            array_push($arrayErros, $mensagem); // ERRO ABAIXO 4
                            
                            //Grava_Erro('  ' + adqAtividade.FieldByName('CDARVINSPEC').DisplayText + '  ' + adqAtividade.FieldByName('NMINSPECAO').AsString + ' - ' + MSG_5);
                            $stOutrasPen = 'S';
                        }
                    }else if($atividadeRow['IDORIGINSPEC'] == 'QUA'){
                        if($atividadeRow['IDPENAND'] == '1' || ($atividadeRow['IDPENAND'] == '2' && $atividadeRow['IDTPCONCLETAPA'] == 'S')){
                            if($stPri == 'S'){
                                // array_push($arrayErros, 'mensagem abaixo');
                                //Grava_Erro(MSG_4);
                                $stPri = 'N';
                            }
                            
                            $mensagem = $atividadeRow['CDARVINSPEC'].' '.$atividadeRow['NMINSPECAO'].' - '.self::MSG_6;
                            array_push($arrayErros, $mensagem);
                            
                            //Grava_Erro('  ' + adqAtividade.FieldByName('CDARVINSPEC').DisplayText + '  ' + adqAtividade.FieldByName('NMINSPECAO').AsString + ' - ' + MSG_6);
                            $stOutrasPen = 'S';
                        }
                    }else if($atividadeRow['IDORIGINSPEC'] == 'ANA'){
                        if($atividadeRow['IDNOK'] == '5' && $atividadeRow['IDTPCONCLETAPA'] == 'S' && $row['IDRESP'] != 'S'){
                            if($stPri == 'S'){
                                // array_push($arrayErros, 'mensagem abaixo');
                                //Grava_Erro(MSG_4);
                                $stPri = 'N';
                            }
                            
                            $stAnaPen = 'S';
                            
                            $mensagem = $atividadeRow['CDPRODUTO'].' '.$atividadeRow['NRLOTEESTQ'];
                            array_push($analisePend, $mensagem);
                            //Grava_Analise('R' + ' ' + adqAtividade.FieldByName('CDPRODUTO').AsString + '  ' + adqAtividade.FieldByName('NRLOTEESTQ').AsString);
                            
                            $mensagem = $atividadeRow['CDARVINSPEC'].' '.$atividadeRow['NMINSPECAO'].' - '.self::MSG_7;
                            array_push($arrayErros, $mensagem);
                            //Grava_Erro('  ' + adqAtividade.FieldByName('CDARVINSPEC').DisplayText + '  ' + adqAtividade.FieldByName('NMINSPECAO').AsString + ' - ' + MSG_7);

                            if($atividadeRow['IDTPAUDITADO'] == 'P' || empty($atividadeRow['IDTPAUDITADO'])){
                                $stOutrasPen = 'S';
                            }
                        }else if(($atividadeRow['IDPENAND'] == '1' || $atividadeRow['IDPENAND'] == '2') && 
                                  $atividadeRow['IDTPCONCLETAPA'] == 'S' && $row['IDRESP'] != 'S'){
                            if($stPri == 'S'){
                                // array_push($arrayErros, 'mensagem abaixo');
                                //Grava_Erro(MSG_4);
                                $stPri = 'N';
                            }

                            $stAnaPen = 'S';
                            $mensagem = $atividadeRow['CDPRODUTO'].' '.$atividadeRow['NRLOTEESTQ'];
                            array_push($analisePend, $mensagem);
                            //Grava_Analise('A' + ' ' + adqAtividade.FieldByName('CDPRODUTO').AsString + '  '+ adqAtividade.FieldByName('NRLOTEESTQ').AsString);
                            
                            $mensagem = $atividadeRow['CDARVINSPEC'].' '.$atividadeRow['NMINSPECAO'].' - '.self::MSG_7;
                            array_push($arrayErros, $mensagem);
                            //Grava_Erro('  ' + adqAtividade.FieldByName('CDARVINSPEC').DisplayText + '  ' + adqAtividade.FieldByName('NMINSPECAO').AsString + ' - ' + MSG_7);
                            
                            if($atividadeRow['IDTPAUDITADO'] == 'P' || empty($atividadeRow['IDTPAUDITADO'])){
                                $stOutrasPen = 'S';
                            }
                        }
                    }
                }
                
                $stPri = 'S';
                
                foreach($rows as $row){
                    
                    if(empty($row['NRLANCESTQ']) &&  ($row['CUSTTOTLOTE'] == 0 || is_null($row['CUSTTOTLOTE']))){
                        if($stPri == 'S'){
                            // array_push($arrayErros, 'erro abaixo 8');
                            //Grava_Erro(MSG_13);
                            $stPri = 'N';
                        }
                        array_push($arrayErros, 'erro abaixo 9');
                        
                        $mensagem = $dadosRow['NMPRODUTO'].' '.$dadosRow['NRLOTEESTQ'].' '.$dadosRow['NRSUBLOTE'].' - '.self::MSG_8;
                        array_push($arrayErros, $mensagem);
                        //Grava_Erro('  ' + cdsDadosNMPRODUTO.AsString + '  ' + 
                        //                  cdsDadosNRLOTEESTQ.AsString + '  '+
                        //                  cdsDadosNRSUBLOTE.AsString + ' - ' + MSG_8);
                        $stOutrasPen = 'S';
                    }
                }
                
                //Verifica inconsistências de acordo com a parametrização do estoque
                $stPri = 'S';
                
            
                foreach($rows as $row){
                    
                    if(empty($row['NRLANCESTQ'])){
                        if($paramFili && $paramFili['IDCTRLESTQ']){
                            if($paramEstoq && $paramEstoq['IDLANCDTMAI'] == 'N' && $paramFili['IDLANCDTMAIFIL'] == 'N' && $row['DTFABRPROD'] > $dataproc){
                                // if($stPri == 'S'){
                                //     array_push($arrayErros, self::MSG_9);
                                //     //Grava_Erro(MSG_9);
                                //     $stPri = 'N';
                                // }
                                
                                $mensagem = "Lote ".$row['NRLOTEESTQ']." ".$row['NRSUBLOTE']." - ".self::MSG_10;
                                array_push($arrayErros, $mensagem);
                                //Grava_Erro('  Lote ' + cdsDadosNRLOTEESTQ.AsString + ' ' + cdsDadosNRSUBLOTE.AsString + ' - ' + MSG_10);
                                $stOutrasPen = 'S';
                            }
                            if($paramEstoq && $paramEstoq['IDLANCDTMEN'] == 'N' && $paramFili['IDLANCDTMENFIL'] == 'N' && $row['DTFABRPROD'] < $dataproc){
                                if($stPri == 'S'){
                                    // array_push($arrayErros, self::MSG_9);
                                    //Grava_Erro(MSG_9);
                                    $stPri = 'N';
                                }
                                
                                $mensagem = 'Lote '.$row['NRLOTEESTQ'].' '.$row['NRSUBLOTE'].' - '.self::MSG_11;
                                array_push($arrayErros, $mensagem);
                                //Grava_Erro('  Lote ' + cdsDadosNRLOTEESTQ.AsString + ' ' + cdsDadosNRSUBLOTE.AsString + ' - ' + MSG_11);
                                $stOutrasPen = 'S';
                            }
                            if($paramEstoq && $paramFili['IDLANCDTMENFIL'] == 'S' && $row['DTFABRPROD'] < $dataproc){
                                if($row['DTFABRPROD'] < ($dataproc - $paramFili['NRDIASENTRFIL'])){
                                    if($stPri == 'S'){
                                        // array_push($arrayErros, self::MSG_9);
                                        //Grava_Erro(MSG_9);
                                        $stPri = 'N';
                                    }
                                    
                                    $mensagem = 'Lote '.$row['NRLOTEESTQ'].' '.$row['NRSUBLOTE'].' - '.self::MSG_12;
                                    array_push($arrayErros, $mensagem);
                                    //Grava_Erro('  Lote ' + cdsDadosNRLOTEESTQ.AsString + ' ' + cdsDadosNRSUBLOTE.AsString + ' - ' + MSG_12);
                                }
                            }else{
                                if($paramEstoq && $paramEstoq['IDLANCDTMEN'] == 'S' && $row['DTFABRPROD'] < $dataproc){
                                    if($row['DTFABRPROD'] < $row['DTFABRPROD'] - $paramEstoq['NRDIASENTR']){
                                        if($stPri == 'S'){
                                            // array_push($arrayErros, self::MSG_9);
                                            //Grava_Erro(MSG_9);
                                            $stPri = 'N';
                                        }
                                        
                                        $mensagem = 'Lote '.$row['NRLOTEESTQ'].' '.$row['NRSUBLOTE'].' - '.self::MSG_12;
                                        array_push($arrayErros, $mensagem);
                                        //Grava_Erro('  Lote ' + cdsDadosNRLOTEESTQ.AsString + ' ' + cdsDadosNRSUBLOTE.AsString + ' - ' + MSG_12);
                                        $stOutrasPen = 'S';
                                    }
                                }
                            }
                            if($paramFili['IDLANCDTMAIFIL'] == 'S' && $row['DTFABRPROD'] > $dataproc){
                                if($row['DTFABRPROD'] > $dataproc + $paramFili['NRDIASENTRPDFIL']){
                                        if($stPri == 'S'){
                                            // array_push($arrayErros, self::MSG_9);
                                            //Grava_Erro(MSG_9);
                                            $stPri = 'N';
                                        }
                                        
                                        $mensagem = 'Lote '.$row['NRLOTEESTQ'].' '.$row['NRSUBLOTE'].' - '.self::MSG_12;
                                        array_push($arrayErros, $mensagem);
                                        //Grava_Erro('  Lote ' + cdsDadosNRLOTEESTQ.AsString + ' ' + cdsDadosNRSUBLOTE.AsString + ' - ' + MSG_12);
                                        $stOutrasPen = 'S';
                                }
                            }else{
                                if($paramEstoq && $paramEstoq['IDLANCDTMAI'] == 'S' && $row['DTFABRPROD'] > $dataproc){
                                    if($row['DTFABRPROD'] > ($dataproc + $paramEstoq['NRDIASENTRPD'])){
                                        if($stPri == 'S'){
                                            // array_push($arrayErros, self::MSG_9);
                                            //Grava_Erro(MSG_9);
                                            $stPri = 'N';
                                        }
                                        
                                        $mensagem = 'Lote '.$row['NRLOTEESTQ'].' '.$row['NRSUBLOTE'].' - '.self::MSG_12;
                                        array_push($arrayErros, $mensagem);
                                        //Grava_Erro('  Lote ' + cdsDadosNRLOTEESTQ.AsString + ' ' + cdsDadosNRSUBLOTE.AsString + ' - ' + MSG_12);
                                        $stOutrasPen = 'S';
                                    } 
                                }
                            }
                        }
                    }
                }
                
                if($stOutrasPen == 'S'){
                    //rollbackaqui
                    //settar array $arrayErros no response aqui
                    //return
                }else if($stAnaPen == 'S'){
                    //rollbackaqui
                    //settar array $arrayAnalisePendente no response aqui
                    //return
                }else{
                   $stOpcao = 'S';
                }
                
                // VOLTAR AQUI 2 - APAGAR
                $stOpcao = 'S';
            
            }
            
            // Atualiza
           
            if($stOpcao == 'S'){
            
                $grid = $this->getGrid($row['CDFILIAL'], $row['NRORDPROD'], $row['NRSUBORDPROD'], 'N');
                
                //Verifica se posssui produtos acabados que nao foram fechados parcialmente
                $vProdNFechados = $this->OpdigitalFactory->adqVProdNFechados($row['CDFILIAL'], $row['NRORDPROD'], $row['NRSUBORDPROD']);
                
                if(!empty($vProdNFechados)){
                    // foreach($vProdNFechados as $prodNFechadosRow){
                    foreach($grid as $gridRow){
                        if($paramFili['IDCTRLESTQ'] == 'S' ){
                            $stNrLancToEst = $this->newCode->getCodeByTableName('LANCTOEST'.$row['CDFILIAL'], 
                                                                                $this->environment->getNrOrgTrab());//novocodigo lancto est aqui
                            
                            $msg =  ''; //acmIns_LancToEstoq.ParamByName('DSLANCESTQ').AsString   := MSG_1 + P_NRORDPROD + '\' + P_NRSUBORDPROD;
                            $insertLanctoestoq = $this->OpdigitalFactory->insertLanctoestoq($row['CDFILIAL'],
                                                                    $stNrLancToEst,
                                                                    date('d/m/Y'),
                                                                    '2',
                                                                    'S',
                                                                    'E',
                                                                    $row['CDFILIAL'],
                                                                    $this->environment->getCdOperador(),
                                                                    $msg);
                            
                            
                            $stDTVALANALOTE = 0;
                            
                            // VOLTAR AQUI 1
                            
                            
                            $filteredAnalisesR = $this->array_some($rows, function($row){
                                return /*$row['DSANALISE']*/ 'teste' == 'R'.' '.$row['CDPRODUTO'].' '.$row['NRLOTEESTQ'];
                            });
                            
                            $filteredAnalisesA = $this->array_some($rows, function($row){
                                return /*$row['DSANALISE']*/ 'teste' == 'A'.' '.$row['CDPRODUTO'].' '.$row['NRLOTEESTQ'];
                            }); 
                            
                            if($filteredAnalisesR){ //cdsAnalise.Locate('DSANALISE', 'R' + ' ' + cdsGrid.FieldByName('CDPRODUTO').AsString + '  ' + cdsGrid.fieldByName('NRLOTEESTQ').AsString, [loCaseInsensitive])
                                $stIDSTANALISE = 'R';
                            }else if($filteredAnalisesA){ //cdsAnalise.Locate('DSANALISE','A' + ' ' + cdsGrid.FieldByName('CDPRODUTO').AsString + '  ' + cdsGrid.fieldByName('NRLOTEESTQ').AsString, [loCaseInsensitive])
                                $stIDSTANALISE = 'A';
                            }else{
                                $stIDSTANALISE = 'L';
                                if(empty($gridRow['NRDIASVALANA'])){
                                    $inDias = 0;
                                    $stDTVALANALOTE = 0;
                                }else{
                                    $inDias = $gridRow['NRDIASVALANA'] * 30;
                                    $stDTVALANALOTE = date('d/m/Y', strtotime(date('Y-m-d'). '+ '.$inDias.'days'));
                                }
                            }
                            
                            if($inDias == 0)
                                $stDTVALANALOTE = 0;
                                
                            $dtconcprod = date('d/m/Y');
                            $dtfabrprod = $paraMan['IDDTLOTELANCOP'] == 'S' || $row['DTFABRPROD'] == 0 ? null : $row['DTFABRPROD'];
                            $dtrealiblote = 0 == 0 ? null : $row['DTREALIBLOTE'];
                            $dtvalanalote = $stDTVALANALOTE == 0 ? null : $stDTVALANALOTE;
                            
                            $this->OpdigitalFactory->updtLote($gridRow['CDFILIAL'],
                                                            $gridRow['CDPRODUTO'],
                                                            $gridRow['NRLOTEESTQ'],
                                                            $gridRow['NRSUBLOTE'],
                                                            '5',
                                                            $dtconcprod,
                                                            $dtfabrprod,
                                                            $dtrealiblote,
                                                            '',
                                                            $stIDSTANALISE,
                                                            $dtvalanalote);
                            
                            if($gridRow['NRSUBLOTE'] == ' '){
                                $stNRSUBLOTE = '';
                            }else{
                                $stNRSUBLOTE = $gridRow['NRSUBLOTE'];
                            }
                            
                            $qtLote = 0;
                            
                            foreach($rows as $row){
                                
                                if($row['NRLOTEESTQ'] == $gridRow['NRLOTEESTQ'] && 
                                   $row['NRSUBLOTE'] == $gridRow['NRSUBLOTE']){
                                    
                                    $adqProdFili = $this->OpdigitalFactory->adqProdFili($row['CDFILIAL'], $row['CDPRODUTO']);
                                    
                                    if($paramFili['IDUTILLOTE'] == 'S'){
                                        //se o produto controla lote por produto
                                        if($adqProdFili['IDUTCTRLLOTE'] == 'S'){
                                            $stNRLOTEESTQ = $row['NRLOTEESTQ'];
                                            $stNRSUBLOTE = $row['NRSUBLOTE'];
                                        }else{
                                            $stNRLOTEESTQ = ' ';
                                            $stNRSUBLOTE = ' ';
                                        }
                                    }else{
                                        $stNRLOTEESTQ = ' ';
                                        $stNRSUBLOTE = ' ';
                                    }
                                    
                                    if(empty($row['NRLANCESTQ'])){
                                        if(empty($row['NRDIASVALANA'])){
                                            $inDias = 0;
                                        }else{
                                            $inDias = $row['NRDIASVALANA'] * 30;
                                        }
                                        
                                        $adqLote = $this->OpdigitalFactory->adqLote($row['CDFILIAL'], 
                                                                                    $row['NRLOTEESTQ'],
                                                                                    $this->resultValue($row['NRSUBLOTE']),
                                                                                    $row['CDPRODUTO']);
                                            
                                        if(!empty($adqLote)){
                                            $stDTVALANALOTE = 0;
                                            
                                            $filteredAnalisesR = $this->array_some($rows, function($row){
                                                return /*$row['DSANALISE']*/ 'teste' == 'R'.' '.$row['CDPRODUTO'].' '.$row['NRLOTEESTQ'];
                                                // cdsAnalise.Locate('DSANALISE' ,'R' + ' ' + cdsDadosCDPRODPROD.AsString + '  ' + cdsDadosNRLOTEESTQ.AsString, [loCaseInsensitive])
                                            });
                                            
                                            $filteredAnalisesA = $this->array_some($rows, function($row){
                                                return /*$row['DSANALISE']*/ 'teste' == 'A'.' '.$row['CDPRODUTO'].' '.$row['NRLOTEESTQ'];
                                                // cdsAnalise.Locate('DSANALISE','A' + ' ' + cdsDadosCDPRODPROD.AsString + '  ' + cdsDadosNRLOTEESTQ.AsString,[loCaseInsensitive])
                                            });
                                            
                                            if($filteredAnalisesR){ //cdsAnalise.Locate('DSANALISE', 'R' + ' ' + cdsGrid.FieldByName('CDPRODUTO').AsString + '  ' + cdsGrid.fieldByName('NRLOTEESTQ').AsString, [loCaseInsensitive])
                                                $stIDSTANALISE = 'R';
                                            }else if($filteredAnalisesA){ //cdsAnalise.Locate('DSANALISE','A' + ' ' + cdsGrid.FieldByName('CDPRODUTO').AsString + '  ' + cdsGrid.fieldByName('NRLOTEESTQ').AsString, [loCaseInsensitive])
                                                $stIDSTANALISE = 'A';
                                            }else{
                                                $stIDSTANALISE = 'L';
                                                $stDTVALANALOTE = date('d/m/Y', strtotime(date('Y-m-d'). '+ '.$inDias.'days'));
                                            }
    
                                            if($inDias == 0){
                                                $stDTVALANALOTE = 0;
                                            }
                                            
                                            $dtconcprod = date('d/m/Y');
                                            $dtfabrprod = $paraMan['IDDTLOTELANCOP'] == 'S' || $row['DTFABRPROD'] == 0 ? null : $row['DTFABRPROD'];
                                            $dtrealiblote = 0 == 0 ? null : $row['DTREALIBLOTE'];
                                            $dtvalanalote = $stDTVALANALOTE == 0 ? null : $stDTVALANALOTE;
    
                                              
                                            $this->OpdigitalFactory->updtLote($row['CDFILIAL'],
                                                                            $row['CDPRODUTO'],
                                                                            $row['NRLOTEESTQ'],
                                                                            $row['NRSUBLOTE'],
                                                                            '5',
                                                                            $dtconcprod,
                                                                            $dtfabrprod,
                                                                            $dtrealiblote,
                                                                            '',
                                                                            $stIDSTANALISE,
                                                                            $dtvalanalote);
                                        }
                                        
                                        // AQUI
                                        try{
                                            // dtmRotiEstoque := TdtmRotiEstoque.Create(nil);
                                            // CDSErro := TCDSErro.Create(nil);
                                            // if not CDSErro.IsEmpty then begin
                                            //     CDSErro.EmptyDataSet;
                                            // end;
                                            
                                            if($adqProdFili && $adqProdFili['IDCNTRESTOQ'] == 'S'){
                                                $seqItem = $this->OpdigitalFactory->adqSeqItemLanc($row['CDFILIAL'], 
                                                                                                    $stNrLancToEst);
                                                
                                                //Insere o lote caso não exista na base de dados
                                                $this->OpdigitalFactory->adqInsLote($row['CDFILIAL'], 
                                                                                    $this->resultValue($stNRLOTEESTQ), 
                                                                                    $this->resultValue($stNRSUBLOTE), 
                                                                                    $row['CDPRODUTO']);
                                                
                                                $this->OpdigitalFactory->insertItLancToEst($cdfilial    = $row['CDFILIAL'], 
                                                                                        $stnrlanctoest  = $stNrLancToEst, 
                                                                                        $nrseqitem      = str_pad($seqItem, 4 , "0", STR_PAD_LEFT),
                                                                                        $cdproduto      = $row['CDPRODUTO'],
                                                                                        $qtlanctoest    = round($row['QTPRODLOTE'], 3), 
                                                                                        $qttotlancto    = round($row['QTPRODLOTE'], 3), 
                                                                                        $cdprodmovi     = $row['CDPRODUTO'], 
                                                                                        $cdfilimovi     = $row['CDFILIAL'], 
                                                                                        $cdalmoxarife   = $this->resultValue($row['CDALMOXARIFE']), 
                                                                                        $cdlocalestoq   = $this->resultValue($row['CDLOCALESTOQ']), 
                                                                                        $nrloteestq     = $this->resultValue($stNRLOTEESTQ), 
                                                                                        $nrsublote      = $this->resultValue($stNRSUBLOTE), 
                                                                                        $identrsaidop   = 'E', 
                                                                                        $idtipomovi     = '2', 
                                                                                        $vrlanctobrut   = round($row['VRPRACABADO'], 5), // CUSTOUNIT
                                                                                        $vrunilancto    = round($row['VRPRACABADO'], 5), // CUSTOUNIT
                                                                                        $vrlanctoest    = round($row['VRPRACABADO'], 5),// CUSTOUNIT
                                                                                        $vrcustentr     = round($row['CUSTOTOT'], 5),  // CUSTTOTLOTE
                                                                                        $vrtotlancto    = round($row['CUSTOTOT'], 5), // CUSTTOTLOTE
                                                                                        $dslancestit    = 'msg',//MSG_14+ ' - ' + P_NRORDPROD + '\' + P_NRSUBORDPROD,
                                                                                        $dtlancmovi     = date('d/m/Y'), 
                                                                                        $idordemclc     = '2');
                                                
                                                
                                                /*$itensEstoq = $this->OpdigitalFactory->adqItLanEst($row['CDFILIAL'], 
                                                                                                    $stnrlanctoest);*/
                                                
                                                // $this->estoqueLibs->atualizaEstoque($row['CDFILIAL'], $stNrLancToEst);
                                                
                                                if($paramFili['IDPERMESTNEG']){
                                                    // dtmRotiEstoque.IrregEstoque([P_CDFILIAL, stNrLancToEst, cdsDadosCDPRODUTO.AsString], False, CDSErro);
                                                }
                                                
                                                if (count($arrayErros) < 1){ // CDSErro.RecordCount <1 - voltar aqui
                                                    
                                                    //Passa o número do lançamento para o produto acabado
                                                    $this->OpdigitalFactory->updtProdAcab($cdfilial     = $row['CDFILIAL'],
                                                                                        $nrordprod      = $row['NRORDPROD'],
                                                                                        $nrsubordprod   = $row['NRSUBORDPROD'],
                                                                                        $cdsubprodeta   = $row['CDSUBPRODETA'],
                                                                                        $nrsubpretaop   = $row['NRSUBPRETAOP'],
                                                                                        $cdproduto      = $row['CDPRODUTO'],
                                                                                        $nrprodacab     = $row['NRPRODACAB'],
                                                                                        $nrlancestq     = $stNrLancToEst,
                                                                                        $nrsequitem     = str_pad($seqItem, 4 , "0", STR_PAD_LEFT));
                                                    
                                                    $qtLote = $qtLote + round($row['QTPRODLOTE'], 3);
                                                    
                                                    //Atualiza a quantidade real produzida do lote
                                                    $this->OpdigitalFactory->xcomAtuQTde($row['CDFILIAL'],
                                                                                        $stNRLOTEESTQ,
                                                                                        $stNRSUBLOTE,
                                                                                        $row['CDPRODUTO'],
                                                                                        round($row['QTPRODLOTE'], 3));     
                                                    // DAR CONTINUIDADE NO BLOCO REFERENTE A RESERVA DO PEDIDO (OP POR PEDIDO - MRP)
                                                    //Altera ou cria uma reserva se a OP for de um Pedido.
                                                    /*$adqOrdProdPed = $this->OpdigitalFactory->adqOrdProdPed($row['CDFILIAL'], 
                                                                                                        $row['NRORDPROD'], 
                                                                                                        $row['NRSUBORDPROD']);
                                                    
                                                    
                                                    if($adqOrdProdPed && !empty($adqOrdProdPed['NRPEDIDO']) && $adqOrdProdPed['IDUTRESELOTE'] == 'S'){
                                                        if(!empty($adqOrdProdPed['NRRESPRODPED'])){
                                                            $this->OpdigitalFactory->acmUpdReserProdPed($row['CDFILIAL'],
                                                                                                        $adqOrdProdPed['NRPEDIDO'],
                                                                                                        $adqOrdProdPed['NRITEMPED'],
                                                                                                        $this->resultValue($row['CDALMOXARIFE']),
                                                                                                        $this->resultValue($row['CDLOCALPRACA']));
                                                        }else{
                                                            $stReserProdPed := '';
                                                        }
                                                    }*/
                                                }else{
                                                    // array_push($arrayErros, self::MSG_9);
                                                    //Grava_Erro(MSG_9);
                                                }
                                            }
                                        } catch(\Exception $e) {
                                	        throw $e;
                                        }
                                    }else{
                                        $qtLote = $qtLote + round($row['QTPRODLOTE'], 3);
                                    }
                                }
                            }
                            
                            $adqExisteItemEst = $this->OpdigitalFactory->adqExisteItemEst($cdfilial, $stNrLancToEst);

                            if($adqExisteItemEst && !($adqExisteItemEst['NRCOUNT'] > 0)){
                                $this->OpdigitalFactory->acmDelLanctoEst($cdfilial, $stNrLancToEst);
                            }
                            
                        } // FIM if($paramFili['IDCTRLESTQ'] == 'S' ){
                        
                        
                        // verificar se será assim msm
                        $stNRLOTEESTQ = ' ';
                        $stNRSUBLOTE = ' ';
                        
                        
                        //Atualiza a quantidade real produzida do lote
                        $this->OpdigitalFactory->xcomAtuQTde($cdfilial,
                                                            $this->resultValue($stNRLOTEESTQ),
                                                            $this->resultValue($stNRSUBLOTE),
                                                            $row['CDPRODUTO'],
                                                            round($qtLote, 3));
            

                        if($paraMan['IDVALIDADEPROD'] == '2'){
                            $prodFili = $this->OpdigitalFactory->adqProdFili($cdfilial, $gridRow['CDPRODUTO']);
                            
                            if($prodFili['IDUTCTRLLOTE'] == 'S'){
                                $this->OpdigitalFactory->acmUpValLote($cdfilial, 
                                                                    $gridRow['CDPRODUTO'],
                                                                    $this->resultValue($stNRLOTEESTQ),
                                                                    $this->resultValue($stNRSUBLOTE));
                            }
                        }
                    } // FIM FOREACH DO GRID

                    //Verifica se OP pode ser fechada
                    /*if($paraMan['IDRECALCQTOP'] == 'S'){
                        
                        //Verifica se a ordem de produção foi gerada através do sistema de Pedidos
                        if(1 == 2){
                            // AQUI EXISTIRÁ A ROTINA QUE BUSCA OP QUE VEIO DO PEDIDO
                            // LINHA 4003 DA CDP06002
                        }else{
                            // busca as Sub ops da op que está sendo fechada
                            $adqOpsPendentes2 = $this->OpdigitalFactory->adqOpsPendentes2($cdfilial, 
                                                                                        $nrordprod);
                                                                                        
                            if($adqOpsPendentes2 && count($adqOpsPendentes2) > 1){
                                $lastAdqOpsPendentes2 = end($adqOpsPendentes2);
                                
                                if(($lastAdqOpsPendentes2['NRORDPROD'] == $nrordprod) && 
                                   ($lastAdqOpsPendentes2['NRORDPROD'] == $nrsubordprod)){
                                    
                                    array_push($arrayErros, 'msg abaixo');
                                    //oleResult[0] := 'OP_N_CONC';
                                }else{
                                    $adqQtdeFechamento = $this->OpdigitalFactory->adqQtdeFechamento($cdfilial,
                                                                                                    $nrordprod,
                                                                                                    $nrsubordprod);
                                    
                                    $adqOpsPendentes2filter = array_filter($adqOpsPendentes2, function($row) use ($nrordprod, $nrsubordprod){
                                        return $row['NRORDPROD']    == $nrordprod
                                            && $row['NRSUBORDPROD'] == $nrsubordprod;
                                    });
                                    
                                    // Verifica se a quantidade que está dando entrada no estoque é igual a quantidade da OP.
                                    // Se não for, deve fazer regra de 3 para atualizar a quantidade das demais OP's  
                                    
                                    if($adqOpsPendentes2filter['QTAPRODPREOP'] <> $adqQtdeFechamento['QTPRACABADO']){
                                        $doAuxQtOrdProd = $adqOpsPendentes2filter['QTAPRODPREOP'];
                                        
                                        foreach($adqOpsPendentes2 as $adqOpsPed){
                                            if(($adqOpsPed['NRORDPROD'] == $nrordprod) &&
                                               ($adqOpsPed['NRSUBORDPROD'] == $nrsubordprod &&
                                               ($adqOpsPed['IDSITORDPROD'] == '1'))){
                                                
                                                $doQtOrdProd = ($adqOpsPed['QTAPRODPREOP'] * $adqQtdeFechamento['QTPRACABADO'] / $doAuxQtOrdProd);
                                                
                                                // acmUpQtdeOp
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }*/
                       
                    
                    // Conclui a ordem de produção     
                    $this->OpdigitalFactory->acmUp_OrdProd('3', date('d/m/Y'), $cdfilial, $nrordprod, $nrsubordprod);
                    
                    $adqOrdensFilhas = $this->OpdigitalFactory->adqOrdensFilhas($cdfilial, $nrordprod, $nrsubordprod);
                    
                    if(!empty($adqOrdensFilhas)){
                        //fazer factory
                        $this->OpdigitalFactory->acmUpStatusCon('3', date('d/m/Y'), $cdfilial, $nrordprod, $nrsubordprod);
                    }
                    
                    if($paraMan['IDUTEQUIPLAPROD'] == 'S'){
                        $this->OpdigitalFactory->xcmLiberaEquip($cdfilial, $nrordprod, $nrsubordprod);
                    }
                    
                    // $this->OpdigitalFactory->insertTesteConexao('B');
                
                }
            }
            
            $arrayErrosAssoc = array();
            $mensagem = array();
            
            if(count($arrayErros) > 0){
                
                foreach($arrayErros as $erro){
                    $mensagem['MENSAGEM'] = $erro;
                    array_push($arrayErrosAssoc, $mensagem);
                }
                
                return $arrayErrosAssoc;
            }else{
                $retorno = 'SUCESSO';
            }

            $this->entityManager->commit();
            return $retorno;
            
        } catch(\Exception $e) {
            $connection->rollback();
	        throw $e;
        }
    }
    
    private function calculaTotProdAcab($gridRow, $prodAcab, $paramMaf){
        try{

            $custotot = 0;
            
            if(($gridRow['QTPRODLOTE'] == $prodAcab['QTPRACABADO']) && ($gridRow['CUSTOUNIT'] == $prodAcab['VRPRACABADO'])){
                $custotot = $prodAcab['CUSTOTOTAL'];
            }else{
                if($paramMaf['IDVRUNITPRACAB'] <> 'S'){
                    $custotot = round($prodAcab['VRPRACABADO'] * $prodAcab['QTPRACABADO'], 5);
                }else{
                    $custotot = $gridRow['CUSTTOTLOTE'];
                }
            }
            
            return $custotot;
        }catch(\Exception $e) {
	        throw $e;
        }
    }
    
    private function getGrid($cdfilial, $nrordprod, $nrsubordprod, $idordprodcons){
        try{
            $grid = $idordprodcons == 'N'? $this->OpdigitalFactory->adqGrid($cdfilial, $nrordprod, $nrsubordprod) : $this->OpdigitalFactory->adqGridCons($cdfilial, $nrordprod, $nrsubordprod);
            return $grid;
        }catch(\Exception $e) {
	        throw $e;
        }
    }
    
    public function acessoOperador($row){   
        try {
            
        } catch(\Exception $e) {
            $this->entityManager->rollback();
	        throw $e;
        }
    }
    
    public function getCountProdRet($row){
        return $this->OpdigitalFactory->getCountProdRet($row['CDFILIAL'], $row['NRORDPROD'], $row['NRSUBORDPROD']);
    }
    
    public function validaQtPrevDifMov($rows){
        $validacoes = array();
        foreach($rows as $row){
            
            //if(paramman.IDBLOQRETMPREV == 'S' && insuReti.IDPRODAGUA == 'N' && insuReti != 'N'){   passar este if para o backend
            if($rows[0]['IDBLOQRETMPREV'] == 'S' && $row['IDPRODAGUA'] == 'N' && $row['IDEVOLESTOQ'] == 'N'){
                $validacao = $this->OpdigitalFactory->adqVdQtPrevDifMov($row['CDFILIAL'], $row['NRRETEST'], $row['CDPRODUTO'], $row['NRSEQRETPROD']);
                array_push($validacoes, $validacao);
            }
        }
        return $validacoes;
    }
    
    public function geraRetirada($cdfilial, $nrordprod, $nrsubordprod, $cdoperador){
        $stNrLancToEst  = '';
        $stNrRetEst     = '';
        $DSLANCESTQ = '????';
        $operador = $this->environment->getCdOperador();
        $veriItemRetiEstData = $this->OpdigitalFactory->adqVerif_ItemRetiEst($cdfilial, $nrordprod, $nrsubordprod);
        foreach($veriItemRetiEstData as $veriItemRetiEstRow){
            $stNrLancToEst = $this->newCode->getCodeByTableName('LANCTOEST'.$veriItemRetiEstRow['CDFILIAL'], $this->environment->getNrOrgTrab());//novocodigo lancto est aqui
            if($tNrRetEst != $veriItemRetiEstRow['NRRETEST']){
                $this->OpdigitalFactory->insertLanctoestoq($veriItemRetiEstRow['CDFILIAL'], $stNrLancToEst, date('d/m/Y'), '3', 'S', 'S', $veriItemRetiEstRow['CDFILIMOVI'], $operador, $DSLANCESTQ);
                $this->OpdigitalFactory->acmUp_NrlanEstq($veriItemRetiEstRow['CDFILIAL'], $stNrLancToEst, $veriItemRetiEstRow['NRRETEST'], $veriItemRetiEstRow['CDFILIAL']);
                $stNrRetEst = $veriItemRetiEstRow['NRRETEST'];
            }
            
            $seqItemLanc = $this->OpdigitalFactory->adqSeqItemLanc($$veriItemRetiEstRow['CDFILIAL'], $stNrLancToEst);
            
            if($veriItemRetiEstRow['IDTPRETEST'] == 'D'){
                $P_IDENTRSAIDOP = 'E';
                $P_IDTIPOMOVI   = '2';
                $P_IDORDEMCLC   = '2';
            }else{
                $P_IDENTRSAIDOP = 'S';
                $P_IDTIPOMOVI   = '3';
                $P_IDORDEMCLC   = '9';
            }
        }
        
    }
    
    public function array_some(array $array, callable $fn) {
        foreach ($array as $value) {
            if($fn($value)) {
                return true;
            }
        }
        return false;
    }

}