function ger04000_nutrientes_por_produto_Controller(ScreenService, General, restEngine) {

	this.salvaProdutoNutrientes = function(widget){
		if(widget.currentRow.QTNUTRPROD < 0){
			ScreenService.showMessage("Quantidade não pode ser negativa.");
		}else {
			if (widget.currentRow.__is_new) {
				General.saveCrud(widget).then(function(){
					ScreenService.successNotification(ScreenService.i18n('Nutriente adicionado com sucesso!'));
				});
			} else {
				widget.saveRow().then(function () {
                    ScreenService.closeSwipe(); 
					widget.reload();
				});	
			}
		}
	};

	this.excluirNutrientes = function (widget) {
		var msg;
		
		if (widget.getCheckedRows().length == 0){
			msg = "Deseja excluir o nutriente " + widget.currentRow.NMNUTRIENTE + "?";
		} else if (widget.getCheckedRows().length > 1) {
			msg = "Deseja excluir os " + widget.getCheckedRows().length + " nutrientes selecionados?";
		} else {
			msg = "Deseja excluir o nutriente " + widget.getCheckedRows()[0].NMNUTRIENTE + "?";
		}
		
		ScreenService.confirmMessage(msg, "question", function () {
			
			if (widget.getCheckedRows().length > 0){
				widget.removeCheckedRows().then(
					function success(argument) {
						return widget.reload().then(function () {
							return ScreenService.successNotification(ScreenService.i18n('Nutriente excluído com sucesso!'));
						});
					},
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela são utilizadas em outras tabelas!');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente.");
							ScreenService.showMessage(msg);
						}
					}
				);
			} else{
				widget.removeRow().then(
					function success(argument) {
						return widget.reload().then(function () {
							ScreenService.closeSwipe();
							return ScreenService.successNotification(ScreenService.i18n('Nutriente excluído com sucesso!'));
						});
					},
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela são utilizadas em outras tabelas!');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente.");
							ScreenService.showMessage(msg);
						}
					}
				);
			}
			
		}, function () {
			widget.unSelectAll();
		});
	};

}

Configuration(function (ContextRegister) {
	ContextRegister.register('ger04000_nutrientes_por_produto_Controller', ger04000_nutrientes_por_produto_Controller);
});