function ger08800_grupo_de_nutrientesController(ScreenService, localStorageEngine, templateManager, General, ZHPromise) {

	this.salvaGrupoNutrientes = function(widget){
		
		if (widget.currentRow.__is_new) {
			General.saveCrud(widget).then(function (){
				General.changeWidgetAcessibility(widget.widgets, true);
				ScreenService.successNotification(ScreenService.i18n('Grupo de nutrientes adicionado com sucesso!'));
			});
		} else {
			widget.saveRow().then(
				function success() {
					var msg = ScreenService.i18n('Grupo de nutrientes alterado com sucesso');
					ScreenService.successNotification(msg);
					General.changeWidgetAcessibility(widget.widgets, true);
					widget.reload();
					ScreenService.closeSwipe();
				},
				function error(error) {
					var msg;
					if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
						ScreenService.showMessage(msg);
					}
				}				
			);	
		}
	};

	this.editaGrupoNutrientes = function (grupoNutrientesWidget) {
		General.edit(grupoNutrientesWidget);
		General.changeWidgetAcessibility(grupoNutrientesWidget.widgets, false	);
		ScreenService.openSwipe(grupoNutrientesWidget);
	};

	this.excluiGrupoNutriente = function (grupoNutrientesWidget) {
		var msg;
		
		if (grupoNutrientesWidget.getCheckedRows().length == 0){
			msg = "Deseja excluir o nutriente " + grupoNutrientesWidget.currentRow.NMGRUPNUTR + "?";
		} else if (grupoNutrientesWidget.getCheckedRows().length > 1) {
			msg = "Deseja excluir os " + grupoNutrientesWidget.getCheckedRows().length + " grupos selecionados?";
		} else {
			msg = "Deseja excluir o grupo " + grupoNutrientesWidget.getCheckedRows()[0].NMGRUPNUTR + "?";
		}
		
		ScreenService.confirmMessage(msg, 'INFORMATION', function () {
			
			if(grupoNutrientesWidget.getCheckedRows().length > 0){
				grupoNutrientesWidget.removeCheckedRows().then(
					function success() {
						grupoNutrientesWidget.reload().then(function(){
							ScreenService.successNotification(ScreenService.i18n('Grupo de Nutrientes excluído com sucesso'));
						});
					},
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela GRUPNUTR são utilizadas na tabela NUTRIENTE');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);	
			} else{
				grupoNutrientesWidget.removeRow().then(
					function success(argument) {
						return grupoNutrientesWidget.reload().then(function () {
							ScreenService.closeSwipe();
							return ScreenService.successNotification(ScreenService.i18n('Nutriente excluído com sucesso!'));
						});
					},
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							msg = ScreenService.i18n('Exclusão não permitida. As informações da tabela são utilizadas em outras tabelas!');
							ScreenService.showMessage(msg);
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente.");
							ScreenService.showMessage(msg);
						}
					}
				);
			}
			
		}, function () {
			grupoNutrientesWidget.unSelectAll();
			templateManager.updateTemplate();
		});
	};

	this.salvaInclusaoNutrientes = function (nutrientesWidget) {
		var nutrienteNovo = nutrientesWidget.currentRow.NMNUTRIENTE;
		var cdgrupnutr = nutrientesWidget.currentRow.CDGRUPNUTR;
		var nmgrupnutr = nutrientesWidget.currentRow.nmgrupnutr;
		var nmgrupalvo = General.getFieldValue('NMGRUPNUTR','GrupoNutrientesWidget');
		var msg;
		
		if(cdgrupnutr == null){
			msg = 'Deseja incluir ' + nutrienteNovo + ' no grupo ' + nmgrupalvo + '?';
		} else if(cdgrupnutr == templateManager.container.getWidget('GrupoNutrientesWidget').fields[0].value()){
			ScreenService.showMessage(nutrienteNovo + ' já faz parte do grupo de ' + nmgrupalvo);
			return;
		} else{
			msg = nutrienteNovo + ' pertence ao grupo de nutrientes ' +  nmgrupnutr + '. Deseja deslocá-lo ao grupo ' + nmgrupalvo + '?';			
		}
		
		ScreenService.confirmMessage(msg, 'INFORMATION', function(){
			nutrientesWidget.currentRow.CDGRUPNUTR = templateManager.container.getWidget('GrupoNutrientesWidget').fields[0].value();
			nutrientesWidget.currentRow.__is_new = false;
			nutrientesWidget.currentRow.changed = true;
		
			nutrientesWidget.saveRow().then(
				function success() {
					nutrientesWidget.reload().then(function(){
						nutrientesWidget.fields[2].reload().then(function(){
							ScreenService.closeSwipe();
							var msg = ScreenService.i18n('Nutriente incluído com sucesso');
							ScreenService.successNotification(msg);	
						});
					});
				},
				function error(error) {
					var msg;
					if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
						ScreenService.showMessage(msg);
					}
				}
			);
		});
	};

	this.excluiNutriente = function (nutrientesWidget) {
		var nmgrupnutr = General.getFieldValue('NMGRUPNUTR', 'GrupoNutrientesWidget');
		var msg;
		
		if(nutrientesWidget.getCheckedRows().length == 0){
			msg = "Deseja excluir o nutriente " + nutrientesWidget.currentRow.NMNUTRIENTE + " do grupo " + nmgrupnutr + "?";
		}
		else if (nutrientesWidget.getCheckedRows().length > 1) {
			msg = "Deseja excluir os " + nutrientesWidget.getCheckedRows().length + " nutrientes selecionados do grupo " + nmgrupnutr + "?";
		} else {
			msg = "Deseja excluir o nutriente " + nutrientesWidget.getCheckedRows()[0].NMNUTRIENTE + " do grupo " + nmgrupnutr + "?";
		}
		
		ScreenService.confirmMessage(msg, 'INFORMATION', function () {
			
			if(nutrientesWidget.dataSource.getCheckedRows().length > 0){
				var excluidos = nutrientesWidget.dataSource.getCheckedRows();
				excluidos.forEach(function (nutriente) {
					nutriente.CDGRUPNUTR = null;
					nutriente.__is_new = false;
					nutriente.changed = true;
				});
				
				nutrientesWidget.dataSource.save().then(
				function success() {
					nutrientesWidget.reload().then(function(){
						nutrientesWidget.fields[2].reload().then(function(){
							nutrientesWidget.unSelectAll();
							msg = ScreenService.i18n('Nutriente(s) excluídos(s) com sucesso');
							ScreenService.successNotification(msg);
						});
					});
				},
				function error(error) {
					if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
						ScreenService.showMessage(msg);
					}
				}
			);
			}else{
				nutrientesWidget.currentRow.CDGRUPNUTR = null;
				nutrientesWidget.currentRow.__is_new = false;
				nutrientesWidget.changed = true;
				
				nutrientesWidget.saveRow().then(
					function success() {
							nutrientesWidget.fields[2].reload().then(function(){
								msg = ScreenService.i18n('Nutriente excluídos com sucesso');
								ScreenService.successNotification(msg);
								ScreenService.closeSwipe().then(function(){
									nutrientesWidget.reload();
								});
							});
					},
					function error(error) {
						if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
					    } else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
					    }
					}
				);
			}
			
		}, function () {
			nutrientesWidget.unSelectAll();
			templateManager.updateTemplate();
		});
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('ger08800_grupo_de_nutrientesController', ger08800_grupo_de_nutrientesController);
});