function ger21000_formas_de_apresentacaoController(ScreenService, templateManager, General, ZHPromise) {

	this.excluir = function (widget) {
		var msg;
		
		if (widget.getCheckedRows().length == 0){
			msg = "Deseja excluir a forma " + widget.currentRow.NMAPRERECE + "?";
		}else if (widget.getCheckedRows().length > 1) {
			msg = "Deseja excluir as " + widget.getCheckedRows().length + " formas selecionadas?";
		} else {
			msg = "Deseja excluir a forma " + widget.getCheckedRows()[0].NMAPRERECE + "?";
		}
		
		return ScreenService.confirmMessage(msg, 'INFORMATION', function () {
			
			if(widget.getCheckedRows().length > 0){
				widget.removeCheckedRows().then(
					function success() {
						widget.reload().then(function(){
							ScreenService.closeSwipe();
							msg = ScreenService.i18n('Forma de apresentação excluída com sucesso');
							return ScreenService.successNotification(msg);
						});
					},
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							ScreenService.showMessage(ScreenService.i18n('Exclusão não permitida. As informações da tabela APRERECE são utilizadas em outras tabelas'));
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);
			} else{
				widget.removeRow().then(
					function success() {
						widget.reload().then(function(){
							ScreenService.closeSwipe();
							msg = ScreenService.i18n('Forma de apresentação excluída com sucesso');
							return ScreenService.successNotification(msg);
						});
					},
					function error(error) {
						if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
							ScreenService.showMessage(ScreenService.i18n('Exclusão não permitida. As informações da tabela APRERECE são utilizadas em outras tabelas'));
						} else if (error.data) {
							msg = ScreenService.i18n(error.data.error);
							ScreenService.showMessage(msg);
						} else {
							msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
							ScreenService.showMessage(msg);
						}
					}
				);
			}
		}, function () {
			widget.unSelectAll();
			templateManager.updateTemplate();
		});
	};

	this.salvar = function (widget) {
		if (widget.isValid()) {
			$("#CDAPRERECE").blur();
			if (widget.currentRow.__is_new) {
				widget.currentRow.DTULTATU = moment().format('L');
				widget.currentRow.NRORG = getLocalVar('NRORGTRAB');
				widget.currentRow.NRORGULTATU = getLocalVar('NRORGTRAB');
				widget.currentRow.CDOPERULTATU = getLocalVar('CDOPERADOR');
			}
			widget.saveRow().then(
				function success(success) {
					widget.list();
					ScreenService.closeSwipe();
					widget.reload();
					ScreenService.successNotification(ScreenService.i18n('Forma de apresentação salva com sucesso'));
				},
				function error(error) {
					var msg;
					if (error.data && error.data.error.indexOf('ORA-00001') !== -1) {
						msg = ScreenService.i18n('Código existente');
						ScreenService.showMessage(msg);
					} else if (error.data) {
						msg = ScreenService.i18n(error.data.error);
						ScreenService.showMessage(msg);
					} else {
						msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
						ScreenService.showMessage(msg);
					}
				}
			);
		}
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('ger21000_formas_de_apresentacaoController', ger21000_formas_de_apresentacaoController);
});