function ger55000_informacoes_adicionais_Controller (templateManager, restEngine, General, ScreenService, ZHPromise, ger55000_informacoes_adicionais_Service){
	
	var self = this;
	
	this.widgetEdit = function(widget){
		
	    if(widget.currentRow == undefined || Object.keys(widget.currentRow).length == 0){
	        
	        widget.currentRow = {};
	        General.widgetNewRow(widget);
	        widget.currentRow.CDPRODUTO = General.getFieldValue('CDPRODUTO', 'grid_produtos');
	        General.formWidgetSwitchTemplate(widget);

	    } else {
	        General.widgetEdit(widget);
	    }
	};
	
	this.widgetSave = function (args) {
        General.widgetSave(args.owner.widget).then(function (response){
                args.owner.widget.list();
        });
	};
	this.atualizaCurrentRow = function() {
		var meuWidget = templateManager.container.getActiveWidget();
        if(meuWidget.dataSource.data[0] == undefined){
        	meuWidget.currentRow = {};
        }
        else {
        	meuWidget.currentRow = meuWidget.dataSource.data[0];
        }
    };
	
	this.backOrCancel = function(args){
	    General.backOrCancel(args).then (function (){
	        self.activateTabs(args);
	    });
	};
	
	this.activateTabs = function(args){
	    General.formWidgetSwitchTemplate(args.owner.widget);
	        var widgetsToActivate = args.owner.widget.parent.widgets;

			General.changeWidgetAcessibility(
				widgetsToActivate.filter(function (subwidget) {
					return subwidget.name != args.owner.widget.name;
				}).concat(args.owner.widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
				true);
				args.owner.widget.list();
	};
	
	this.valida_ProdutoAte = function(widget) {
	    var limite;
	    var popup = widget.__filterPopup;
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var CDARVPRODINI_IsSelected = !!popup.currentRow.CDARVPRODINI;
        
        var Nmarvprodfinfield = popup.getField('NMARVPRODFIN');
        var Nmarvprodinifield = popup.getField('NMARVPRODINI');
        
        Nmarvprodinifield.dataSource.data.forEach(function(obj){
            if(obj.CDARVPROD === popup.currentRow.CDARVPRODINI){
                limite = obj.ROWNUM;
            }
        });

        // Altera as propriedades do field 'Lote__Ate' e reseta seu valor.
        if(CDARVPRODINI_IsSelected)
            Nmarvprodfinfield.validations.required = CDARVPRODINI_IsSelected;
        else
            delete(Nmarvprodfinfield.validations.required);
        Nmarvprodfinfield.readOnly = !CDARVPRODINI_IsSelected;
        Nmarvprodfinfield.setValue(null);
        Nmarvprodfinfield.needReload = true;
        popup.currentRow.limite = limite;
    };    
    
    this.prodFin = function(widget){
	    var popup = widget.__filterPopup;
        var limite = popup.currentRow.limite;
        var dataArrayProdFin = popup.getField('NMARVPRODFIN').dataSource.data;
        
        dataArrayProdFin.splice(0, limite);
        
    };
    
    this.validateFilterPopup = function(widget){
        var popup = widget.__filterPopup;
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var CDARVPRODINI = popup.currentRow.CDARVPRODINI;
        
        var CDARVPRODFIN = popup.currentRow.CDARVPRODFIN;
        var Nmarvprodfinfield = popup.getField('NMARVPRODFIN');

        // Altera as propriedades do field 'Lote__Ate' e reseta seu valor.
        if((!(CDARVPRODINI && CDARVPRODFIN)) || (CDARVPRODINI === CDARVPRODFIN)){
            widget.dataSourceFilter[3].value = 'T';
            widget.dataSourceFilter[0].value = '';
            widget.dataSourceFilter[1].value = '';
        }
        else{
            widget.dataSourceFilter[3].value = '';
            widget.dataSourceFilter[0].value = CDARVPRODINI;
            widget.dataSourceFilter[1].value = CDARVPRODFIN;
            delete(Nmarvprodfinfield.validations.required);
        }
            
    };
    
    this.saveInfo = function(args){
        var widget = args.owner.widget;
        try{
            self.save(widget).then(function(){
                General.modEdit(widget);
                General.cancelModEdit(args);
            });
        } catch (e) {
			ScreenService.showMessage(e);
		}
    };
    
    this.save = function(widget){
    		var deferred = ZHPromise.defer();
    
    		if (widget.isValid()) {
    			widget.currentRow.changed = true;
    
    			if (!widget.currentRow.__is_new)
    				widget.currentRow.__is_new = false;
    			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
    				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
    				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
    				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
    				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
    				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
    			}
    
    			ger55000_informacoes_adicionais_Service.saveInfo(widget).then(function (response) {
    				widget.currentRow.changed = false;
    				delete widget.backupRow;
    
    				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
    					widget.view();
    
    					var widgets = widget.parent.widgets;
    					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
    				} else {
    					if (widget.currentRow.__is_new) {
    						ScreenService.closeSwipe();
    						widget.view();
    					} else widget.view();
    
    					General.changeWidgetAcessibility(widget.widgets, true);
    				}
    
    				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
    				deferred.resolve(response);
    			}, function (error) {
    				var errorMessage = 'Timeout';
    
    				if (error.data) errorMessage = error.data.error;
    
    				ScreenService.showMessage(errorMessage);
    				deferred.reject(errorMessage);
    			});
    		} else deferred.reject("Preencha todos os campos corretamente!");
    
    		return deferred;
    };
    
    this.deleteRefBibOrCondArm = function(widget){
        var deferred = ZHPromise.defer();
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
		    var field = widget.fields[1];
		    field.setValue('');
			General.widgetSave(widget).then(function () {
			    General.formWidgetSwitchTemplate(widget);
				widget.list();
				widget.activate();
				deferred.resolve();
			}, function (error) {
				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
					ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
				} else {
					ScreenService.showMessage(error.data.error);
				}
				deferred.reject();
			});
		});
		return deferred.promise;
    };
    
    this.deleteDadosQuimicos = function(widget){
        var deferred = ZHPromise.defer();
		ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
		    var formula = widget.getField('DSFORMULAMOL');
		    var peso = widget.getField('VRPESOMOL');
		    formula.setValue('');
		    peso.setValue('');
			General.widgetSave(widget).then(function () {
			    General.formWidgetSwitchTemplate(widget);
				widget.list();
				widget.activate();
				deferred.resolve();
			}, function (error) {
				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
					ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
				} else {
					ScreenService.showMessage(error.data.error);
				}
				deferred.reject();
			});
		});
		return deferred.promise;
    };
    
    this.saveTextBlob = function(args){
        var widget = args.owner.widget;
        try{
        	switch(widget.name){
        		case "tabbed_DCB":
        			saveDCB(widget).then(function(){
		                widget.formTemplate = widget.templateToView;
		            });
        			break;
        		case "tabbed_CAS":
        			saveCAS(widget).then(function(){
		                widget.formTemplate = widget.templateToView;
		            });
        			break;
        		case "tabbed_INCI":
        			saveINCI(widget).then(function(){
		                widget.formTemplate = widget.templateToView;
		            });
        			break;
        		case "tabbed_DCI":
        			saveDCI(widget).then(function(){
		                widget.formTemplate = widget.templateToView;
		            });
        			break;
        		
        	}
        } catch (e) {
			ScreenService.showMessage(e);
		}
    };
    
    function saveDCB(widget){
    		var deferred = ZHPromise.defer();
    
    		if (widget.isValid()) {
    			widget.currentRow.changed = true;
    
    			if (!widget.currentRow.__is_new)
    				widget.currentRow.__is_new = false;
    			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
    				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
    				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
    				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
    				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
    				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
    			}
    
    			ger55000_informacoes_adicionais_Service.saveDCB(widget).then(function (response) {
    				widget.currentRow.changed = false;
    				delete widget.backupRow;
    
    				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
    					widget.list();
    
    					var widgets = widget.parent.widgets;
    					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
    				} else {
    					if (widget.currentRow.__is_new) {
    						ScreenService.closeSwipe();
    						widget.list();
    					} else widget.list();
    
    					General.changeWidgetAcessibility(widget.widgets, true);
    				}
    
    				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
    				deferred.resolve(response);
    			}, function (error) {
    				var errorMessage = 'Timeout';
    
    				if (error.data) errorMessage = error.data.error;
    
    				ScreenService.showMessage(errorMessage);
    				widget.formTemplate = widget.templateToView;
    				deferred.reject(errorMessage);
    			});
    		} else deferred.reject("Preencha todos os campos corretamente!");
    
    		return deferred;
    }
    
    function saveCAS(widget){
    		var deferred = ZHPromise.defer();
    
    		if (widget.isValid()) {
    			widget.currentRow.changed = true;
    
    			if (!widget.currentRow.__is_new)
    				widget.currentRow.__is_new = false;
    			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
    				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
    				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
    				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
    				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
    				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
    			}
    
    			ger55000_informacoes_adicionais_Service.saveCAS(widget).then(function (response) {
    				widget.currentRow.changed = false;
    				delete widget.backupRow;
    
    				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
    					widget.list();
    
    					var widgets = widget.parent.widgets;
    					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
    				} else {
    					if (widget.currentRow.__is_new) {
    						ScreenService.closeSwipe();
    						widget.list();
    					} else widget.list();
    
    					General.changeWidgetAcessibility(widget.widgets, true);
    				}
    
    				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
    				deferred.resolve(response);
    			}, function (error) {
    				var errorMessage = 'Timeout';
    
    				if (error.data) errorMessage = error.data.error;
    
    				ScreenService.showMessage(errorMessage);
    				deferred.reject(errorMessage);
    			});
    		} else deferred.reject("Preencha todos os campos corretamente!");
    
    		return deferred;
    }
    
    function saveINCI(widget){
    		var deferred = ZHPromise.defer();
    
    		if (widget.isValid()) {
    			widget.currentRow.changed = true;
    
    			if (!widget.currentRow.__is_new)
    				widget.currentRow.__is_new = false;
    			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
    				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
    				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
    				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
    				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
    				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
    			}
    
    			ger55000_informacoes_adicionais_Service.saveINCI(widget).then(function (response) {
    				widget.currentRow.changed = false;
    				delete widget.backupRow;
    
    				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
    					widget.list();
    
    					var widgets = widget.parent.widgets;
    					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
    				} else {
    					if (widget.currentRow.__is_new) {
    						ScreenService.closeSwipe();
    						widget.list();
    					} else widget.list();
    
    					General.changeWidgetAcessibility(widget.widgets, true);
    				}
    
    				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
    				deferred.resolve(response);
    			}, function (error) {
    				var errorMessage = 'Timeout';
    
    				if (error.data) errorMessage = error.data.error;
    
    				ScreenService.showMessage(errorMessage);
    				deferred.reject(errorMessage);
    			});
    		} else deferred.reject("Preencha todos os campos corretamente!");
    
    		return deferred;
    }
    
    function saveDCI(widget){
    		var deferred = ZHPromise.defer();
    
    		if (widget.isValid()) {
    			widget.currentRow.changed = true;
    
    			if (!widget.currentRow.__is_new)
    				widget.currentRow.__is_new = false;
    			else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
    				widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
    				widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
    				widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
    				widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
    				widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
    			}
    
    			ger55000_informacoes_adicionais_Service.saveDCI(widget).then(function (response) {
    				widget.currentRow.changed = false;
    				delete widget.backupRow;
    
    				if (General.formWidgetSwitchTemplate(widget) && widget.parent) {
    					widget.list();
    
    					var widgets = widget.parent.widgets;
    					General.changeWidgetAcessibility(widgets.concat(widget.parent), true);
    				} else {
    					if (widget.currentRow.__is_new) {
    						ScreenService.closeSwipe();
    						widget.list();
    					} else widget.list();
    
    					General.changeWidgetAcessibility(widget.widgets, true);
    				}
    
    				if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
    				deferred.resolve(response);
    			}, function (error) {
    				var errorMessage = 'Timeout';
    
    				if (error.data) errorMessage = error.data.error;
    
    				ScreenService.showMessage(errorMessage);
    				deferred.reject(errorMessage);
    			});
    		} else deferred.reject("Preencha todos os campos corretamente!");
    
    		return deferred;
    }
      
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ger55000_informacoes_adicionais_Controller', ger55000_informacoes_adicionais_Controller);
});