function QPR01900_Inspecao_Digital_Controller (localStorageEngine, templateManager, restEngine, General, ScreenService, QPR01900_Inspecao_Digital_Service){
    
    var cdChecklist;
    var nrOrdProd;
    var nrSubOrdProd;
    
    var mensagens = [];
    mensagens.filtroIncompleto = "É necessário preencher todos os campos do Filtro.";
    
    var currentQuest;
    var currentQuestPosDataSource;
    var currentQuestPosInterface;
    var currentCadQuest;
    var currentCadQuestNewCode;
    var originalRow;
    var cadRowsToDelete = [];
    
    this.openFilter = function(args) {
        ScreenService.openPopup(templateManager.container.getWidget('TarefaFilter'));
        templateManager.container.getWidget('TarefaFilter').isVisible = true;
    };
    
    this.checkFilter = function(args) {
        var row = args.owner.field.widget.currentRow;
        
        args.owner.field.widget.getField('LANCAMENTOFIN').setValue(null);
        args.owner.field.widget.getField('LANCAMENTOFIN').readOnly = !row.LANCAMENTOINI;
        if (row.LANCAMENTOINI) {
            args.owner.field.widget.getField('LANCAMENTOFIN').minDate = args.owner.field.widget.getField('LANCAMENTOINI').value();
        }
    };
    
    this.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("ger#/crud/operador", filter);
    };    
        
    this.getLocalData = function() {
        var mainWidget = templateManager.container.getWidget('inspecao_digital');
        var filterWidget = templateManager.container.getWidget('TarefaFilter');
        
        if (filterWidget.currentRow.LANCAMENTOINI && filterWidget.currentRow.LANCAMENTOFIN) {
            var minDate = filterWidget.currentRow.LANCAMENTOINI;
            var maxDate = filterWidget.currentRow.LANCAMENTOFIN;
            var params = [];
            
            this.retornaOperadorLogado().then(function(callback){
                params.push(callback[0].CDOPERADOR);
                params.push(minDate);
                params.push(maxDate);
                QPR01900_Inspecao_Digital_Service.searchTarefaQuestao(params).then(function(success){
                    
                    localStorageEngine.setDataSource('inspecaoTarefa', success.dataset.resultados.tarefa);
                    localStorageEngine.setDataSource('inspecaoQuestao', success.dataset.resultados.questao);
                    localStorageEngine.setDataSource('respostaVal', success.dataset.resultados.respostaVal);
                    localStorageEngine.setDataSource('respostaBool', success.dataset.resultados.respostaBool);
                    localStorageEngine.setDataSource('respostaCad', success.dataset.resultados.respostaCad);
                    localStorageEngine.setDataSource('respQuestVisBoo', success.dataset.resultados.respQuestVisBoo);
                    localStorageEngine.setDataSource('respQuestVar', success.dataset.resultados.respQuestVar);
                    localStorageEngine.setDataSource('respQuestCad', success.dataset.resultados.respQuestCad);
                    
                    localStorageEngine.getDataSource('inspecaoTarefa', []).then(function(inspecaoTarefa) {
                        mainWidget.dataSource.data = inspecaoTarefa;
                        ScreenService.closePopup();
                        ScreenService.closePopup();
                    });
                }.bind(this));
            });
        } else {
            ScreenService.showMessage(mensagens.filtroIncompleto);
        }
    };
    
    this.questionApplyFilter = function(widget) {
        
        var filter = [{
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": cdChecklist
        }, {
            "name": "NRORDPROD",
            "operator": "=",
            "value": nrOrdProd
        }, {
            "name": "NRSUBORDPROD",
            "operator": "=",
            "value": nrSubOrdProd
        }];
        
        localStorageEngine.getDataSource('inspecaoQuestao', filter).then(function(inspecaoQuestao) {
            templateManager.container.getWidget('WidgetQuestoes').dataSource.data = inspecaoQuestao;
         });
    }.bind(this);
    
    this.openRespWidget = function(widget) {
        localStorageEngine.getDataSource('inspecaoQuestao').then(function(inspecaoQuestao) {
            var found = false;
            for(var i=0; i<inspecaoQuestao.length && found==false; i++) {
                if (inspecaoQuestao[i].NRQUESTCHECK == widget.currentRow.NRQUESTCHECK && inspecaoQuestao[i].CDCHECKLIST == widget.currentRow.CDCHECKLIST && inspecaoQuestao[i].NRORDPROD == widget.currentRow.NRORDPROD && inspecaoQuestao[i].NRSUBORDPROD == widget.currentRow.NRSUBORDPROD) {
                    for(var j=0; j<widget.dataSource.data.length && found==false; j++) {
                    	if (widget.dataSource.data[j] == widget.currentRow) {
                    	    found = true;
                	        this.currentQuest = inspecaoQuestao[i];
                	        this.currentQuestPosDataSource = i;
                	        this.currentQuestPosInterface = j;
                            if (widget.currentRow.TPQUESTCHECK == 'BOO') {
                                this.openBoolResp();
                            }
                            if (widget.currentRow.TPQUESTCHECK == 'VAL') {
                                this.openValResp();
                            }
                            if (widget.currentRow.TPQUESTCHECK == 'VIS') {
                                this.openVisResp();
                            }
                            if (widget.currentRow.TPQUESTCHECK == 'CAD') {
                                this.openCadResp();
                            }
                        }
                    }
                }
            }
        }.bind(this));
    };
    
    this.openVisResp = function() {
        var filter = [{
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": cdChecklist
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }];
       localStorageEngine.getDataSource('respostaBool', filter).then(function(respostaBool) {
           localStorageEngine.getDataSource('respQuestVisBoo').then(function(respQuestVisBoo) {
               localStorageEngine.getDataSource('inspecaoQuestao').then(function(inspecaoQuestao) {
        		if (this.currentQuest.IDSITQUESTAROP == 3) {
        		    this.currentQuest.IDSITQUESTAROP = 1;
        		} else {
        		    this.currentQuest.IDSITQUESTAROP = 3;
        		}
        		
        		var found = false;
        		for (var i=0; i<respQuestVisBoo.length && found == false; i++) {
        		    if (respQuestVisBoo[i].NRORDPROD == this.currentQuest.NRORDPROD && respQuestVisBoo[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
        		        found = true;
        		        if (this.currentQuest.IDSITQUESTAROP == 1) {
        		            respQuestVisBoo[i].IDRESPVISTO = 'NOK';   
        		        } else respQuestVisBoo[i].IDRESPVISTO = 'SOK';    
        		    }
        		}
        		if (found == false) {
        		    respQuestVisBoo.push(this.makeVisBooResp('Vis', this.currentQuest.IDSITQUESTAROP));
        		}
        		
                inspecaoQuestao[this.currentQuestPosDataSource] = this.currentQuest;
                localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                localStorageEngine.setDataSource('respQuestVisBoo', respQuestVisBoo);
        	    templateManager.container.getWidget('WidgetQuestoes').dataSource.data[this.currentQuestPosInterface].IDSITQUESTAROP = inspecaoQuestao[this.currentQuestPosDataSource].IDSITQUESTAROP;
        		
    		    if (respostaBool[0].DSRESPVISTO) {
    		        ScreenService.showMessage(respostaBool[0].DSRESPVISTO);
    		    }
                this.colorizeQuestion();
               }.bind(this));
           }.bind(this));
       }.bind(this));
    
    };
    
    this.openBoolResp = function() {
        var boolRespWidget = templateManager.container.getWidget('WidgetBoolResp');
        localStorageEngine.getDataSource('respostaBool').then(function(respostaBool) {
            var found = false;
            ScreenService.openPopup(boolRespWidget);
            
            for (var i=0; i<respostaBool.length && found == false; i++) {
                if (respostaBool[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                    found = true;
                    boolRespWidget.fields[0].dataSource.data[0].NMRESPBOOL = respostaBool[i].DSRESPFALSO;
                    boolRespWidget.fields[0].dataSource.data[1].NMRESPBOOL = respostaBool[i].DSRESPVERD;
                }
            }
        }.bind(this));
    };
    
    this.openValResp = function() {
        var valRespWidget = templateManager.container.getWidget('WidgetValResp');
        ScreenService.openPopup(valRespWidget);
    };
    
    this.confirmBoolResp = function(widget) {
        var Value = widget.currentRow.IDRESPBOOL;
        
        var filter = [{
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": cdChecklist
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }];
        
        localStorageEngine.getDataSource('respostaBool', filter).then(function(respostaBool) {
            localStorageEngine.getDataSource('respQuestVisBoo').then(function(respQuestVisBoo) {
                if (respostaBool) {
                    localStorageEngine.getDataSource('inspecaoQuestao').then(function(inspecaoQuestao) {
                        if (Value == 'F') {
                            this.currentQuest.IDSITQUESTAROP = '2';
                            inspecaoQuestao[this.currentQuestPosDataSource] = this.currentQuest;
                            localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                        } else if (Value == 'V') {
                            this.currentQuest.IDSITQUESTAROP = '3';
                            inspecaoQuestao[this.currentQuestPosDataSource] = Util.clone(this.currentQuest);
                            localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                        }
                        
                        var found = false;
                		for (var i=0; i<respQuestVisBoo.length && found == false; i++) {
                		    if (respQuestVisBoo[i].NRORDPROD == this.currentQuest.NRORDPROD && respQuestVisBoo[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                		        found = true;
                		        if (this.currentQuest.IDSITQUESTAROP == 2) {
                		            respQuestVisBoo[i].IDVERDFALSO = 'N';   
                		        } else if (this.currentQuest.IDSITQUESTAROP == 3) respQuestVisBoo[i].IDVERDFALSO = 'S';    
                		    }
                		}
                		if (found == false) {
                		    respQuestVisBoo.push(this.makeVisBooResp('Bool', this.currentQuest.IDSITQUESTAROP));
                		}
                        
                        localStorageEngine.setDataSource('respQuestVisBoo', respQuestVisBoo);
                        templateManager.container.getWidget('WidgetQuestoes').dataSource.data[this.currentQuestPosInterface].IDSITQUESTAROP = inspecaoQuestao[this.currentQuestPosDataSource].IDSITQUESTAROP;
                        ScreenService.closePopup();
                        this.colorizeQuestion();
                    }.bind(this));
                } else {
                    ScreenService.showMessage('Não existe este tipo de resposta.');
                }
                this.colorizeQuestion(); 
            }.bind(this));
         }.bind(this));
    };
    
    this.confirmValResp = function(widget) {
        var Value = widget.currentRow.RESPVAL;
        
        var filter = [{
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": cdChecklist
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }];
        
        localStorageEngine.getDataSource('respostaVal', filter).then(function(respostaVal) {
            
            var found = false;
            var response;
            var responseValue;
            
            for(var i=0; i<respostaVal.length && found==false; i++) {
                if (respostaVal[i].TPFXVR == '<') {
                    if (Value < respostaVal[i].FXINICIAL) {
                        found = true;
                    }
                } else if (respostaVal[i].TPFXVR == '>') {
                    if (Value > respostaVal[i].FXINICIAL) {
                        found = true;
                    }
                } else if (respostaVal[i].TPFXVR == 'E') {
                    if (Value >= respostaVal[i].FXINICIAL && Value <= respostaVal[i].FXFINAL) {
                        found = true;
                    }
                }
                if (found) {
                    response = respostaVal[i].DSRESPVR;
                    responseValue = respostaVal[i].PONTVRCHECK;
                }
            }
            
            if (found) {
                ScreenService.showMessage(response);
                localStorageEngine.getDataSource('inspecaoQuestao').then(function(inspecaoQuestao) {
                    localStorageEngine.getDataSource('respQuestVar').then(function(respQuestVar) {
                        if (responseValue == 'I') {
                            this.currentQuest.IDSITQUESTAROP = '2';
                            inspecaoQuestao[this.currentQuestPosDataSource] = this.currentQuest;
                            localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                        } else if (responseValue == 'C' || responseValue == 'A') {
                            this.currentQuest.IDSITQUESTAROP = '3';
                            inspecaoQuestao[this.currentQuestPosDataSource] = Util.clone(this.currentQuest);
                            localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                        }
                        
                        var found = false;
                		for (var i=0; i<respQuestVar.length && found == false; i++) {
                		    if (respQuestVar[i].NRORDPROD == this.currentQuest.NRORDPROD && respQuestVar[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                		        found = true;
                		        respQuestVar[i].VRRESPTAR = Value;   
                		    }
                		}
                		if (found == false) {
                		    respQuestVar.push(this.makeVarResp(Value));
                		}
                        
                        localStorageEngine.setDataSource('respQuestVar', respQuestVar);
                        templateManager.container.getWidget('WidgetQuestoes').dataSource.data[this.currentQuestPosInterface].IDSITQUESTAROP = inspecaoQuestao[this.currentQuestPosDataSource].IDSITQUESTAROP;
                        ScreenService.closePopup();
                        this.colorizeQuestion();
                    }.bind(this));
                }.bind(this));
            } else {
                ScreenService.showMessage('Não existe este tipo de resposta.');
            }
            this.colorizeQuestion();
         }.bind(this));
    };
    
    this.colorizeQuestion = function() {
        var list = document.querySelector('body > span > section > section > div.default-window.ng-scope > section.zh-swipe-container.zh-swipe-right.ng-scope.open > div > div:nth-child(3) > section > section > div > section > div > div.container.zh-list-container.ng-scope.ng-isolate-scope.nonbounce > ul');
        list = list.querySelectorAll('li.zh-list-item-label');

        if (this.currentQuest.IDSITQUESTAROP == '3'){
            list[this.currentQuestPosInterface].childNodes[7].querySelectorAll('div.row')[1].style.color = 'green';   
        } else if (this.currentQuest.IDSITQUESTAROP == '2'){
            list[this.currentQuestPosInterface].childNodes[7].querySelectorAll('div.row')[1].style.color = 'red';   
        } else if (this.currentQuest.IDSITQUESTAROP == '1'){
            list[this.currentQuestPosInterface].childNodes[7].querySelectorAll('div.row')[1].style.color = 'black';   
        } 
    };
    
    this.colorizeAllQuestions = function() {
        var list = document.querySelector('body > span > section > section > div.default-window.ng-scope > section.zh-swipe-container.zh-swipe-right.ng-scope.open > div > div:nth-child(3) > section > section > div > section > div > div.container.zh-list-container.ng-scope.ng-isolate-scope.nonbounce > ul');
        list = list.querySelectorAll('li.zh-list-item-label');
        
        for(var i=0; i<list.length; i++) {
            var span = list[i].childNodes[7].querySelectorAll('div.row')[1].childNodes[1].childNodes[3].innerHTML;
            
            if (span == 'Pendente.') {
                list[i].childNodes[7].querySelectorAll('div.row')[1].style.color = 'black';   
            } else if (span == 'Correta.') {
                list[i].childNodes[7].querySelectorAll('div.row')[1].style.color = 'green';
            } else if (span == 'Incorreta.') {
                list[i].childNodes[7].querySelectorAll('div.row')[1].style.color = 'red';
            }
        }
        
    };
    
    this.openCadResp = function() {
        var cadHolderRespWidget = templateManager.container.getWidget('WidgetCadRespHolder');
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var CadRespView =   templateManager.container.getWidget('WidgetCadRespView');
        localStorageEngine.getDataSource('respQuestCad').then(function(respQuestCad) {
            var currentResp = [];
            for (var i=0; i<respQuestCad.length; i++) {
                if (respQuestCad[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                    currentResp.push(respQuestCad[i]);
                }
            }
            
            for (i=0; i<cadRespWidget.actions.length; i++) {
                cadRespWidget.actions[i].isVisible = true;
            }
            
            cadRespWidget.dataSource.data = currentResp;
            
            localStorageEngine.getDataSource('respostaCad').then(function(respostaCad) {
                var found = false;
                for (var i=0; i<respostaCad.length && found == false; i++) {
                    if (respostaCad[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                        found = true;
                        
                        this.currentCadQuest = respostaCad[i];
                        
                        if(respostaCad[i].IDPRODUTO == 'S') {
                            cadRespWidget.fields[1].isVisible = true;
                            CadRespView.fields[0].isVisible = true;
                            if(respostaCad[i].IDLOTE == 'S') {
                                cadRespWidget.fields[3].readOnly = true;
                                CadRespView.fields[2].readOnly = true;
                            }
                        }
                        if(respostaCad[i].IDEQUIPA == 'S') {
                            cadRespWidget.fields[2].isVisible = true;
                            CadRespView.fields[1].isVisible = true;
                        }
                        if(respostaCad[i].IDLOTE == 'S') {
                            cadRespWidget.fields[3].isVisible = true;
                            CadRespView.fields[2].isVisible = true;
                        }
                        if(respostaCad[i].IDOPERADOR == 'S') {
                            cadRespWidget.fields[4].isVisible = true;
                            CadRespView.fields[3].isVisible = true;
                        }
                        
                        if(respostaCad[i].DSCOLUNA1) {
                            CadRespView.fields[4].isVisible = true;
                            CadRespView.fields[4].label = respostaCad[i].DSCOLUNA1;
                        }
                        if(respostaCad[i].DSCOLUNA2) {
                            CadRespView.fields[5].isVisible = true;
                            CadRespView.fields[5].label = respostaCad[i].DSCOLUNA2;
                        }
                        if(respostaCad[i].DSCOLUNA3) {
                            CadRespView.fields[6].isVisible = true;
                            CadRespView.fields[6].label = respostaCad[i].DSCOLUNA3;
                        }
                        if(respostaCad[i].DSCOLUNA4) {
                            CadRespView.fields[7].isVisible = true;
                            CadRespView.fields[7].label = respostaCad[i].DSCOLUNA4;
                        }
                        if(respostaCad[i].DSCOLUNA5) {
                            CadRespView.fields[8].isVisible = true;
                            CadRespView.fields[8].label = respostaCad[i].DSCOLUNA5;
                        }
                        if(respostaCad[i].DSCOLUNA6) {
                            CadRespView.fields[9].isVisible = true;
                            CadRespView.fields[9].label = respostaCad[i].DSCOLUNA6;
                        }
                        if(respostaCad[i].DSCOLUNA7) {
                            CadRespView.fields[10].isVisible = true;
                            CadRespView.fields[10].label = respostaCad[i].DSCOLUNA7;
                        }
                        if(respostaCad[i].DSCOLUNA8) {
                            CadRespView.fields[11].isVisible = true;
                            CadRespView.fields[11].label = respostaCad[i].DSCOLUNA8;
                        }
                        if(respostaCad[i].DSCOLUNA9) {
                            CadRespView.fields[12].isVisible = true;
                            CadRespView.fields[12].label = respostaCad[i].DSCOLUNA9;
                        }
                        
                        ScreenService.openSwipe(cadHolderRespWidget);
                    }
                }
            }.bind(this));
        }.bind(this));
    };
    
    this.openCadRespView = function(widget) {
        var CadRespView = templateManager.container.getWidget('WidgetCadRespView');
        
        if (CadRespView.actions[0].isVisible == false) {
           for (var i=0; i<3; i++) {
               CadRespView.actions[i].isVisible = true;
           }
            
            CadRespView.currentRow = widget.currentRow;
            ScreenService.openSwipe(CadRespView);
            CadRespView.list();
        }
    };
        
    
    this.returnCadResp = function() {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var questWidget = templateManager.container.getWidget('WidgetQuestoes');
        ScreenService.closeSwipe();
        
        cadRespViewWidget.fields.forEach(function(item){ 
            item.isVisible = false;
        });
        
        cadRespWidget.fields.forEach(function(item){ 
            item.isVisible = false;
        });
        
        cadRespWidget.actions.forEach(function(item){ 
            item.isVisible = false;
        });
        
        questWidget.actions.forEach(function(item){ 
            item.isVisible = true;
        });
        
        questWidget.activate();
    };
    
    this.returnCadRespView = function() {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        
        cadRespViewWidget.actions.forEach(function(item){ 
            item.isVisible = false;
        });
        this.currentCadQuestNewCode = null;
        ScreenService.closeSwipe();
        cadRespWidget.activate();
    };
    
    this.checkQueStstate = function() {
        var questWidget = templateManager.container.getWidget('WidgetQuestoes');
        var filter = [{
            "name": "NRORDPROD",
            "operator": "=",
            "value": nrOrdProd
        }];
        
        localStorageEngine.getDataSource('inspecaoQuestao', filter).then(function(inspecaoQuestao) {
            localStorageEngine.getDataSource('respQuestCad', filter).then(function(respQuestCad) {
                for(var i=0; i<inspecaoQuestao.length; i++) {
                    if (inspecaoQuestao[i].TPQUESTCHECK == 'CAD') {
                        var found = false;
                        for(var j=0; j<respQuestCad.length && found == false; j++) {
                            if (respQuestCad[j].NRQUESTCHECK == inspecaoQuestao[i].NRQUESTCHECK) {
                                found = true;
                                inspecaoQuestao[i].IDSITQUESTAROP = 3;
                            }
                        }
                        if (found == false) {
                            inspecaoQuestao[i].IDSITQUESTAROP = 1;
                        }
                    }
                }
                localStorageEngine.setDataSource('inspecaoQuestao', inspecaoQuestao);
                templateManager.container.getWidget('WidgetQuestoes').dataSource.data = inspecaoQuestao;
            }.bind(this));    
        }.bind(this));
    };
    
    this.openWidgetCadNew = function() {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        
        cadRespViewWidget.actions[4].isVisible = true;
        cadRespViewWidget.actions[6].isVisible = true;
        
        cadRespViewWidget.currentRow = [];
        cadRespViewWidget.currentRow.__is_new = true;
        ScreenService.openSwipe(cadRespViewWidget);
        cadRespViewWidget.edit();
    };
    
    this.lockLote = function(args) {
        var row = args.owner.field.widget.currentRow;
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        
        if(this.currentCadQuest.IDLOTE == 'S') {
            if (args.owner.field.widget.getField('NMPRODUTO')) {
                var filter = {
                    "name": "CDPRODUTO",
                    "operator": "=",
                    "value": args.owner.field.widget.currentRow.CDPRODUTO
                };
                
                cadRespViewWidget.fields[2].dataSourceFilter[1] = filter;
            }
            
            cadRespViewWidget.fields[2].readOnly = !row.NMPRODUTO;
            cadRespViewWidget.fields[2].clearValue();
        }
    };
    
    this.editCadResp = function(widget) {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        widget.edit();
        cadRespViewWidget.currentRow.__is_new = false;
        this.originalRow = Util.clone(widget.currentRow);
        
        if (cadRespViewWidget.currentRow.NMPRODUTO && cadRespViewWidget.currentRow.NRLOTEESTQ) {
            cadRespViewWidget.fields[2].readOnly = true;
        } else {
            cadRespViewWidget.fields[2].readOnly = false;
        }
        
        cadRespViewWidget.actions[3].isVisible = true;
        cadRespViewWidget.actions[5].isVisible = true;
    };
  
    this.cancelCadRespEdit = function(widget) {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        if (widget.currentRow.__is_new) {
          widget.dataSource.data.pop();
          widget.reload();
        } else { 
          Util.extend(widget.currentRow, this.originalRow);
        }
        
        cadRespViewWidget.actions[3].isVisible = false;
        cadRespViewWidget.actions[5].isVisible = false;
        widget.list();
    };
    
    this.saveCadRespEdit = function(widget) {
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        var filter = [{
            "name": "CDRESPCAD",
            "operator": "=",
            "value": widget.currentRow.CDRESPCAD
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }, {
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": this.currentQuest.CDCHECKLIST
        }, {
            "name": "NRORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRORDPROD
        }, {
            "name": "NRSUBORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRSUBORDPROD
        }];
        
        if (this.currentCadQuestNewCode != null) {
            filter[0] = {
                "name": "CDRESPCAD",
                "operator": "=",
                "value": this.currentCadQuestNewCode
            };
        }
        
        localStorageEngine.getDataSource('respQuestCad', filter).then(function(respQuestCad) {
            localStorageEngine.getDataSource('respQuestCad').then(function(respQuestCadAll) {
                var found = false;
                var currentResp = [];
                for (var i=0; i<respQuestCadAll.length && found==false; i++) {
                    if (this.currentCadQuestNewCode != null) {
                        if (respQuestCadAll[i].CDRESPCAD == this.currentCadQuestNewCode && respQuestCadAll[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                            found = true;
                            respQuestCadAll[i] = this.makeCadResp(widget, this.currentCadQuestNewCode);
                            localStorageEngine.setDataSource('respQuestCad', respQuestCadAll);
                        }
                    } else { 
                        if (respQuestCadAll[i].CDRESPCAD == widget.currentRow.CDRESPCAD && respQuestCadAll[i].NRQUESTCHECK == widget.currentRow.NRQUESTCHECK) {
                            found = true;
                            respQuestCadAll[i] = widget.currentRow;
                            localStorageEngine.setDataSource('respQuestCad', respQuestCadAll);
                        }
                    }
                }
                widget.reload();
                for (i=0; i<respQuestCadAll.length; i++) {
                    if (respQuestCadAll[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                        currentResp.push(respQuestCadAll[i]);
                    }
                }
                cadRespWidget.dataSource.data = currentResp;
                widget.list();
                
                cadRespViewWidget.actions[3].isVisible = false;
                cadRespViewWidget.actions[5].isVisible = false;
            }.bind(this));
        }.bind(this));
        
    };
    
    this.saveNewCadResp = function(widget) {
        var cadRespViewWidget = templateManager.container.getWidget('WidgetCadRespView');
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var filter = [{
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": this.currentQuest.NRQUESTCHECK
        }, {
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": this.currentQuest.CDCHECKLIST
        }, {
            "name": "NRORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRORDPROD
        }, {
            "name": "NRSUBORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRSUBORDPROD
        }];
        
        localStorageEngine.getDataSource('respQuestCad', filter).then(function(respQuestCad) {
            localStorageEngine.getDataSource('respQuestCad').then(function(respQuestCadAll) {
                var currentResp = [];
                
                var maxCode = 0;
                for(var i=0; i<respQuestCad.length; i++) {
                    if (maxCode < parseInt(respQuestCad[i].CDRESPCAD)) {
                        maxCode = parseInt(respQuestCad[i].CDRESPCAD);
                    }
                }
                
                var newResp = this.makeCadResp(widget, this.zeroFill(maxCode+1));
                respQuestCadAll.push(newResp);
                localStorageEngine.setDataSource('respQuestCad', respQuestCadAll);
                
                for (i=0; i<respQuestCadAll.length; i++) {
                    if (respQuestCadAll[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                        currentResp.push(respQuestCadAll[i]);
                    }
                }
                cadRespWidget.dataSource.data = currentResp;
                cadRespWidget.reload();
                
                cadRespViewWidget.actions.forEach(function(item){ 
                    item.isVisible = false;
                });
                this.currentCadQuestNewCode = newResp.CDRESPCAD;
                this.openCadRespView(widget);
                this.checkQueStstate();
            }.bind(this));
        }.bind(this));
    };
    
    this.removeCadResp = function(widget) {
        var cadRespWidget = templateManager.container.getWidget('WidgetCadResp');
        var filter = [{
            "name": "CDRESPCAD",
            "operator": "=",
            "value": widget.currentRow.CDRESPCAD
        }, {
            "name": "NRQUESTCHECK",
            "operator": "=",
            "value": widget.currentRow.NRQUESTCHECK
        }, {
            "name": "CDCHECKLIST",
            "operator": "=",
            "value": this.currentQuest.CDCHECKLIST
        }, {
            "name": "NRORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRORDPROD
        }, {
            "name": "NRSUBORDPROD",
            "operator": "=",
            "value": this.currentQuest.NRSUBORDPROD
        }];
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            localStorageEngine.getDataSource('respQuestCad').then(function(respQuestCadAll) {
                var found = false;
                var currentResp = [];
                for (var i=0; i<respQuestCadAll.length && found==false; i++) {
                    if (respQuestCadAll[i].CDRESPCAD == widget.currentRow.CDRESPCAD && respQuestCadAll[i].NRQUESTCHECK == widget.currentRow.NRQUESTCHECK) {
                        found = true;
                        cadRowsToDelete.push(respQuestCadAll[i]);
                        respQuestCadAll.splice(i, 1);
                        localStorageEngine.setDataSource('respQuestCad', respQuestCadAll);
                    }
                }
                widget.reload();
                for (i=0; i<respQuestCadAll.length; i++) {
                    if (respQuestCadAll[i].NRQUESTCHECK == this.currentQuest.NRQUESTCHECK) {
                        currentResp.push(respQuestCadAll[i]);
                    }
                }
                cadRespWidget.dataSource.data = currentResp;
                cadRespWidget.reload();
                ScreenService.closeSwipe();
                this.checkQueStstate();
            }.bind(this));
		}.bind(this));
    };
    
    //função responsável por colocar "0" atrás do número
    this.zeroFill = function(number) {
    	if (number<10) {
    		return "00" + number;
        } else if (number<100) {
            return "0" + number;
        } return number;
    };
    
    this.getFilterData = function(widget) {
       cdChecklist =  widget.currentRow.CDCHECKLIST;
       nrOrdProd = widget.currentRow.NRORDPROD;
       nrSubOrdProd = widget.currentRow.NRSUBORDPROD;
       this.checkQueStstate();
    };
    
    this.sendChanges = function() {
        localStorageEngine.getDataSource('inspecaoQuestao', []).then(function(inspecaoQuestao) {
            localStorageEngine.getDataSource('respQuestVisBoo', []).then(function(respQuestVisBoo) {
                localStorageEngine.getDataSource('respQuestVar', []).then(function(respQuestVar) {
                    localStorageEngine.getDataSource('respQuestCad', []).then(function(respQuestCad) {

                        var rows = {};
                        rows[0] = inspecaoQuestao;
                        rows[1] = respQuestVisBoo;
                        rows[2] = respQuestVar;
                        rows[3] = respQuestCad;
                        rows[4] = cadRowsToDelete;
                        
                        for(var i=0; i < rows[0].length; i++) {
                            delete rows[0][i].TPQUESTCHECK;
                            delete rows[0][i].DSQUESTCHECK;
                        }
                        
                        QPR01900_Inspecao_Digital_Service.sendChanges(rows).then(function(success){
                            ScreenService.showMessage('Mudanças salvas com sucesso.');
                            
                            for(var i=0; i < rows.length; i++) {
                                for(var j=0; i < rows[i].length; j++) {
                                    rows[i][j].__is_new = false;
                                }
                            }
                            
                        });
                    }.bind(this));
                }.bind(this));
            }.bind(this));
        });
    };
    
    this.makeVisBooResp = function(type, idresp) {
        var newResp = {
            CDFILIAL: this.currentQuest.CDFILIAL,
            CDCHECKLIST: this.currentQuest.CDCHECKLIST,
            NRORDPROD: this.currentQuest.NRORDPROD,
            NRSUBORDPROD: this.currentQuest.NRSUBORDPROD,
            NRQUESTCHECK: this.currentQuest.NRQUESTCHECK,
            CDETAPAPROD: this.currentQuest.CDETAPAPROD,
            CDINSPECAO: this.currentQuest.CDINSPECAO,
            CDHABILIDADE: this.currentQuest.CDHABILIDADE,
            NRAUDITORIA: this.currentQuest.NRAUDITORIA,
            NRINSPECAUDI: this.currentQuest.NRINSPECAUDI,
            IDATIVO: this.currentQuest.IDATIVO,
            NRORG: this.currentQuest.NRORG,
            NRORGULTATU: this.currentQuest.NRORGULTATU,
            CDOPERULTATU: this.currentQuest.CDOPERULTATU,
            __is_new: true
        };
        
        if (type == 'Vis') {
            if (idresp == 1) {
                newResp.IDRESPVISTO = 'NOK';
            } else {
                newResp.IDRESPVISTO = 'SOK';
            }
        } else {
            if (idresp == 2) {
                newResp.IDVERDFALSO = 'N';
            } else {
                newResp.IDVERDFALSO = 'S';
            }
        }
        
        return newResp;
    };
    
    this.makeVarResp = function(valresp) {
        var newResp = {
            CDFILIAL: this.currentQuest.CDFILIAL,
            CDCHECKLIST: this.currentQuest.CDCHECKLIST,
            NRORDPROD: this.currentQuest.NRORDPROD,
            NRSUBORDPROD: this.currentQuest.NRSUBORDPROD,
            NRQUESTCHECK: this.currentQuest.NRQUESTCHECK,
            CDETAPAPROD: this.currentQuest.CDETAPAPROD,
            CDINSPECAO: this.currentQuest.CDINSPECAO,
            CDHABILIDADE: this.currentQuest.CDHABILIDADE,
            NRAUDITORIA: this.currentQuest.NRAUDITORIA,
            NRINSPECAUDI: this.currentQuest.NRINSPECAUDI,
            IDATIVO: this.currentQuest.IDATIVO,
            NRORG: this.currentQuest.NRORG,
            NRORGULTATU: this.currentQuest.NRORGULTATU,
            CDOPERULTATU: this.currentQuest.CDOPERULTATU,
            __is_new: true,
            VRRESPTAR: valresp
        };
        
        return newResp;
    };
    
    this.makeCadResp = function(widget, code) {
        var newResp = {
            CDFILIAL: this.currentQuest.CDFILIAL,
            CDCHECKLIST: this.currentQuest.CDCHECKLIST,
            NRORDPROD: this.currentQuest.NRORDPROD,
            NRSUBORDPROD: this.currentQuest.NRSUBORDPROD,
            NRQUESTCHECK: this.currentQuest.NRQUESTCHECK,
            CDETAPAPROD: this.currentQuest.CDETAPAPROD,
            NRINSPECAUDI: this.currentQuest.NRINSPECAUDI,
            CDHABILIDADE: this.currentQuest.CDHABILIDADE,
            CDINSPECAO: this.currentQuest.CDINSPECAO,
            NRAUDITORIA: this.currentQuest.NRAUDITORIA,
            CDRESPCAD: code,
            CDPRODUTO: widget.currentRow.CDPRODUTO,
            NMPRODUTO: widget.currentRow.NMPRODUTO,
            CDEQUIPPRO: widget.currentRow.CDEQUIPPRO,
            NMEQUIPPRO: widget.currentRow.NMEQUIPPRO,
            NRLOTEESTQ: widget.currentRow.NRLOTEESTQ,
            CDOPERADOR: widget.currentRow.CDOPERADOR,
            NMOPERADOR: widget.currentRow.NMOPERADOR,
            COL1: widget.currentRow.COL1,
            COL2: widget.currentRow.COL2,
            COL3: widget.currentRow.COL3,
            COL4: widget.currentRow.COL4,
            COL5: widget.currentRow.COL5,
            COL6: widget.currentRow.COL6,
            COL7: widget.currentRow.COL7,
            COL8: widget.currentRow.COL8,
            COL9: widget.currentRow.COL9,
            __is_new: true
        };
        
        return newResp;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('QPR01900_Inspecao_Digital_Controller', QPR01900_Inspecao_Digital_Controller);
});